PhoA

PhoA — Arrange Your Pictures!

Copyright ©2002-2005 DK Software, www.dk-soft.org


Purpose of the program

Nowadays it becomes more and more popular to store pictures in an electronic form, as computer files. Undoubtedly this way has lots of benefits compare to keeping "hard copies" of photos, drawings etc: an electronic picture does not take so much space (a regular recordable CD-R disc can hold as much as about 5000 photos in JPEG format of quite good quality), it can be easily duplicated, shown and even presented to all of your and others' relatives, pals and enemies (the latter can be achieved by mailing it by email, it could be even better, particularly for pictures above 10-20 MB in size).

Unfortunately some thousands pictures are very hard to search through. The most obvious and simple solution might be arranging the files into folders with the appropriate names ("We and our dog", "Our dog alone" etc), but this leads to more and more contradictions: how can you arrange pictures by date and, at once, by subject, by event and at the same time by place; how can you attach description to a picture (although some programs allow to write it in, they do it pretty difficult); and finally how are you going to find that unique picture of you and your dog where he is jumping off 5th floor for you out of that heap of some 1287 pics?

These tasks seemed unpretentious had emboldened me to write a picture cataloguing program capable of arranging and search various pictures (drawings, photos, screenshots and all other stuff).

Like it or not, but the program's got the name PhoA - an acronym for 'Photo Album', and photo album files the program creates also wear extension .phoa.

Next >>

Copyright ©2002-2005 DK Software. All rights reserved.


How it works

The main program principle is storing the links to the pictures or, to be more specific, to picture files. As long as pictures are stored separately, it is possible to copy them independently from program, to view them with third-party tools as well as to reduce the space needed to copy a link.

Pictures are arranged (gathered) into groups, and the group are arranged hierarchically as a tree, similar to folder tree in the Windows Explorer. Groups are displayed as folders in the left program window pane while the pictures contained in the group do so in the right pane.

Note that groups do not directly link the pictures. These links are stored in a common list (containing links to all photo album pictures), items of which containt description data.

Groups are filled from this common link list so groups contain "links to links to pictures". If that's still not clear then look to the picture:

What does it tell us about? It does tell us that picture once described in PhoA can be added to any (or even all) of the groups thus copying only link to it and keeping the actual link to the file (with appropriate description, date, place etc) only once.

Next >>


Supported file formats

As was mentioned above, PhoA program works with photo album files having .phoa extension - such file holds:

  • photo album description text and settings;
  • picture list along with their descriptions;
  • folders-groups hierarchy, each holding a set of links to photo album images;
  • views' structures (PhoA version 1.0.1+).

.phoa files cannot be viewed directly and are opened only in PhoA. But starting with PhoA version 1.1.1a that is possible to create your own tools due to open PhoA file format specifications. Refer to program's home site for further information.

Current version recognises the following formats as source image files (click a plus-button to expand the details):

Standard Windows and OS/2 bitmap images (*.bmp, *.rle, *.dib)

  • byte order: little endian
  • sample sizes: 1, 4, 8 bits per sample
  • color spaces: indexed, RGB(A)
  • compression formats: uncompressed, RLE

JPEG images (*.jpg; *.jpeg; *.jpe)

  • byte orders: little endian, big endian
  • sample sizes: 8 bits per sample
  • color spaces: grayscale, RGB

TIFF images (*.tif; *.tiff; *.dng)

  • byte orders: little endian, big endian
  • sample sizes: 1, 2, 4, 8, 16 bits per sample
  • color spaces: indexed, grayscale, RGB(A), CMYK, L*a*b*
  • compression formats: uncompressed, packed bits, LZW, CCITT T.4 (raw and modified fax group 3, possibly word aligned), ThunderScan, Deflate, new style JPEG

GFI fax images (*.fax)

  • sample size: 1 bits per sample
  • color space: indexed
  • compression format: CCITT T.4 (raw and modified fax group 3)

SGI images (*.bw, *.rgb, *.rgba, *.sgi)

  • byte order: big endian
  • sample sizes: 1, 2, 4, 8, 16 bits per sample
  • color spaces: indexed, grayscale, RGB(A)
  • compression formats: uncompressed, RLE

Autodesk images files (*.cel; *.pic)

  • byte order: little endian
  • sample size: 8 bits per sample
  • color spaces: indexed
  • compression format: uncompressed

Truevision Targa images (*.tga; *.vst; *.icb; *.vda; *.win)

  • byte order: little endian
  • sample sizes: 5, 8 bits per sample
  • color spaces: gray scale, indexed, 15 bits RGB (555), 24 bits RGB(A)(888)
  • compression formats: uncompressed, RLE

ZSoft Paintbrush images (*.pcx, *.pcc)

  • byte order: little endian
  • sample sizes: 1, 2, 4, 8 bits per sample
  • color spaces: gray scale, indexed, RGB
  • compression formats: uncompressed, RLE

Word 5.x screen capture files (*.scr)

  • byte order: little endian
  • sample sizes: 1, 2, 4, 8 bits per sample
  • color spaces: indexed, gray scaleRGB
  • compression formats: uncompressed, RLE

Kodak Photo-CD images (*.pcd)

  • byte order: little endian
  • samples size: 8 bits per sample
  • color space: YCbCr
  • compression: PCD Huffmann
  • specials:
    • sizes: all resolutions, from 192 x 128 up to 6144 x 4096 (64 Base vaporware)
    • rotated: clockwise and counter-clockwise

Portable pixel/gray map images (*.ppm, *.pgm, *.pbm)

  • byte order: little endian
  • sample sizes: 1, 8 bits per sample
  • color spaces: gray scale, indexed, RGB
  • compression format: uncompressed
  • specials:
    • ASCII and Binary format

Dr. Halo images (*.cut, *.pal)

  • byte order: little endian
  • sample size: 8 bits per sample
  • color spaces: indexed
  • compression formats: RLE
  • specials:
    • external palette file (*.pal) is automatically loaded

CompuServe GIF images (*.gif)

  • byte order: little endian
  • sample sizes: 1, 4, 8 bits per sample
  • color spaces: indexed
  • compression format: LZW
  • specials:
    • interlaced, non-interlaced

SGI Wavefront images (*.rla, *.rpf)

  • byte order: big endian
  • sample size: 8 bits per sample
  • color space: RGB(A)
  • compression formats: RLE

Photoshop images (*.psd, *.pdd)

  • byte order: big endian
  • sample sizes: 1, 8, 16 bits per sample
  • color spaces: indexed, RGB, CMYK, CIE L*a*b*
  • compression formats: uncompressed, packed bits
  • special:
    • duo tone

Paint Shop Pro images (*.psp)

  • byte order: little endian
  • sample sizes: 1, 4, 8 bits per sample
  • color spaces: indexed, gray scale, RGB
  • compression formats: uncompressed, LZ77

Portable Network Graphic images (*.png)

  • byte order: big endian
  • sample sizes: 1, 2, 4, 8, 16 bits per sample
  • color spaces: indexed, grayscale (alpha), RGB(A)
  • compression format: LZ77
  • specials:
    • supported chunks: IHDR, IDAT, IEND, PLTE, gAMA, tRNS, bKGD
    • transparency support partially for RGB, which is stored as 32 bits format

The powerful image format support is implemented thanks to Mike Lischke.

Next >>


Thumbnails

Maximum dimensions of thumbnails being created for added pictures depend on album properties (ie. every photo album can hold its own thumbnail specifications), the default values is 150 by 150 pixels. If a picture does not fit these dimensions, thumbanail is created by scaling the picture appropriately.

PhoA thumbnails are always stored in JPEG format, which causes from the most effective compression of this format. You can control the quality of thumbnails being created with program settings: higher thumbnail quality simplifies picture identification but causes more space usage. Because thumbnails are contained within photo album files (*.phoa), their dimensions and quality directly affect resulting album file size as well as space allocated for album in memory when opening it.

Next >>


Major modes

PhoA program can work in two major modes:

  • browsing and arranging pictures;
  • viewing pictures.

These modes are functionally the same as in some well-known program (needn't to pronounce names). Things do not like making them twice...

Browse mode

In this mode the main application window is very similar to standard Windows Explorer: there's a group (folder) tree in the left pane, and thumbnail and their descriptions are being displayed in the right pane for the selected group. In the browse mode you are able to create new group in the album, to add, delete and edit pictures in a group, to drag-and-drop pictures across the groups as well as perform some additional operations.

learn more >>

View mode

That would be slightly strange if picture-arranging program doesn't have some functional tool for viewing them. In PhoA this mode allows viewing single pictures (source, ie. ones on that thumbnails are created). Viewing supports image scaling (zooming in/out) and scrolling it, advancing to the next, previous, the first and the next picture in the group, switching between full-screen and window modes.

learn more >>

Next >>


PhoA features and advantages

It's definitely obvious that PhoA gives you many benefits when working with the photos, drawings and other highly creative artworks:

  • The program does not require installation and (presently) consists of the only file phoa.exe. What does it mean? This means it can be copied along with created photo album file (*.phoa) everywhere you wish. When recording it on a CD-R having placed appropriate autorun.inf file to the root of the CD you can demostrate your pictures on any PC by simply inserting the CD in (on PCs keeping autorun feature turned on). The program won't blame you even if it couldn't find phoa.chm file beside, which represents PhoA Help System.
  • The program allows you to build up catalogues (called photo albums) on completely different pictures. Pictures are arranged into groups similar to folders in Windows Explorer. Source images can be almost of any raster format, and also a number of vector formats are supported. Details on supported file formats are here.
  • Each picture may be described by date, place, film and frame number, keywords, description, author and so on. A thumbnail - shrinked view of a picture - is generated automatically (a number of resampling algorithms implemented). Thumbnail dimensions can be specified in photo album properties, thumbnails themselves are stored in the photo album file; this allows nearly instant photo album opening and viewing. Thumbnails are being compressed using JPEG algorithm.
  • PhoA allows momentary photo album searches by picture file name, by date range, place, keywords, description text etc.; search results are displayed as a group-tree node and can be merged with pictures from any group.
  • Photo album file holds relative paths to pictures thus allowing to move it anywhere just keeping the photo album file's original relation to pictures. But when photo album file is placed on a different disk or on a network server (and vice versa: picture files are on a network disk while the photo album file resides on the local one), then the album file holds absolute paths and its placement relative to these pictures doesn't matter.
  • There's an option for displaying thumbnails' tooltips in the browse mode. Tooltips' content is also adjustable.
  • PhoA implements a picture sorting feature for selected group or the whole photo album. Sorting criteria include almost all available data, sorting set may contain arbitrary number of criteria; the last used set is remembered.
  • There are views implemented: a brand-new technology for the browse mode. You can classify a heap of pictures into folders with minimum efforts. The only requirement is that pictures' properties are properly filled. These properties are used for grouping pictures in tree folders. Possible grouping conditions are: by picture file path, by date and time (in various ways), by place, by keywords etc. Groupings may be cascaded, ie may be applied one by one, number of groupings is a matter of sanity. The result of the grouping (folder tree along with their pictures) may be easily put into any photo album group, and after that you can tweak them in usual way.
  • PhoA is capable for viewing pictures (in window or full-screen mode) as well as their descriptions. Viewing parameters are adjusted in program settings; there are slideshow mode, picture scaling (zoom in and out with a number of resampling algorithms) and panning with mouse or keyboard. Pictures are being decoded by a parallel thread thus allowing background loading while viewing another picture. Also there's an option for caching the last viewed picture.
  • The program supports clipboard operations: you can copy or cut selected pictures into the clipboard and paste them into another group or even another photo album; there's also a possibility to paste files in Explorer or file list in a text editor.
  • There is fully operational undo system: any wrong operation may be rolled back (the same for group of operations). The undo buffer capacity is specified through PhoA settings.
  • The program allows performing of some kinds of file operations: copying, moving, deletion etc. In particular there's a built-in mechanism for preparing the photo album (or view, or any part of them) for writing onto a CD, DVD or another removable medium.
  • There are also a number of tool features (statistics, inter-group operations etc.)
  • PhoA looks good, has pretty suave manner and a handly interface. What else you may need?

Note. Photo album file (.phoa) format is subject to change along with program is being developed. I will make maximum efforts to keep the downward compatibility, ie newer program versions should open (and even save) files of older versions.

Next >>


System requirements

For the program to install you need an operating system, some disk space and a bit of RAM. To be more specific, PhoA runs under Windows 95/98/ME/NT/2000/XP, takes approximately 2 MB of disk space and requires at least 16 MB of installed RAM. Because entire photo album file being opened is loaded into RAM, when opening file containing a lot of pictures (1000+) it is recommended to have adequate amount of RAM (32-64 MB on Windows 95/98/ME/NT, 128 MB on Windows 2000 & XP).

Next >>


Picture data

The current version of PhoA allows storage, retrieval and editing (if a field is editable) the following data for each picture. Moreover, if a field is marked as searchable you may search pictures by its data.
Name | Data type | Editable | Searchable | Description
ID | Ordinal | No | Yes | Internal unique picture identifier. In the photo album always has the only corresponding file name. Used for identifying the picture, and for creating links to it.
Picture file name | Filename string | No | Yes | Picture file name (without path)
Full picture file name | Filename string | No | No | Picture file name with path. Full file name is an unique value among all photo album pictures.
Picture file path | String | No | Yes | Only path part of full picture file name.
Picture file size | String | No | No | "Human readable" representation of picture file size, eg 212,45 Kbytes or 839 bytes.
Picture file size in bytes | Integer | No | Yes | Picture file size expressed in bytes, eg 678233.
Picture width | Integer | No | Yes | Picture width in pixels.
Picture height | Integer | No | Yes | Picture height in pixels.
Picture dimensions | Size | No | No | Picture dimensions in pixels represented in form Width x Height, eg 1024x768.
Thumbnail image width | Integer | No | Yes | Thumbnail image width in pixels.
Thumbnail image height | Integer | No | Yes | Thumbnail image height in pixels.
Thumbnail image dimensions | Size | No | No | Thumbnail image dimensions in pixels represented in form Width x Height, eg 150x100.
Picture format | Pixel format | No | No | Pixel format of the image, eg 1-bit (monochrome) or Device dependent.
Date | Date | Yes | Yes | Date of events on the picture, ranged from Jan 1, 0001 to Dec 31, 9999.
Time | Time | Yes | Yes | Time of events on the picture, ranged from 00:00:01 (value of 00:00:00 assumed to be no value) to 23:59:59.
Place | String | Yes | Yes | Place of the picture.
Film number or name | String | Yes | Yes | If the picture was taken with film camera - number assigned to the film containing picture when it was being developed (unique as a rule), or name given to it by you.
Frame number | String | Yes | Yes | If the picture was taken with film camera - number of frame with the picture, eg 20 or 4A.
Author | String | Yes | Yes | Author's or photographer's, which made the picture, name.
Media name or code | String | Yes | Yes | Name of the media containing picture file (eg, CD-ROM number).
Keywords | String list | Yes | Yes | List of keywords regarding the picture - people or things, for exapmle. Always alphabetically sorted, comparison is always case insensitive.
Description | String | Yes | Yes | Brief description of what is picture displays, designated to be shown while viewing (the recommended purpose).
Notes | String | Yes | Yes | Any data not contained in other fields.
Rotation | Angle | Yes | No | An image rotation angle for viewing, a multiple of 90°. Refer to Transformations for details.
Flips | Flag set | Yes | No | A set of flags determining the applied picture flips for viewing: [Horizontal, Vertical]. Refer to Transformations for details.

See also:

Browse mode
Working in the browse mode
Find pictures dialog
Edit pictures dialog


Revision History

This document summarizes the differences between versions of PhoA in reverse chronological order.

Photo album file version differences

Program versions

PhoA 1.1.9
[Jan 21, 2005]
  • It is now allowed to create a view with no groupings. For example, a view can have a filter expression only.
  • Other fixes (details are on the site - check the Mantis Issue Tracker).
PhoA 1.1.8 beta
[Dec 31, 2004]
  • A long-awaited change picture file feature: File properties page of the Picture properties dialog.
  • Initial support for DNG (Digital Negative) image format from Adobe.
  • Failsafe photo album file saving.
  • Optimized unlinked picture search and remove routine which allows for significantly faster group and picture deletion.
  • Other fixes (details are on the site - check the Mantis Issue Tracker).
PhoA 1.1.7 beta
[Dec 07, 2004]
  • A possibility for using the fast JPEG decoding library IJL (Intel JPEG Library) as a plugin. When ijl15.dll is present in Plugins directory, the program automatically utilizes it for decoding JPEG files which results in speed increase up to 300%.
  • Many optimizations to thumbnail creating mechanism which benefits even more from using IJL and results in just a crazy thumbnail rebuilding speed.
  • Andrew Dudko has written initial expression parser routines; this allowed to implement a brand-new picture search interface with using filter expressions.
  • The same expression can now be used to filter pictures in a view.
  • The former search interface is also available (now called Simple search). A possibility of adding an arbitrary number of criteria by any properties of a picture.
  • New searchable/displayable picture properties: thumbnail width, height and dimensions.
  • Preview feature in the Add pictures wizard at both Select files and Check file pages.
  • Ctrl+Right click on View and Adjust page of the Picture properties dialog now also invokes a shell context menu.
  • Other fixes (details are on the site - check the Mantis Issue Tracker).
PhoA 1.1.6 beta
[Nov 09, 2004]
  • Completely reworked program localization mechanism. All you need to do to add a new interface language is place a transaltion file into the Language folder. The translation file itself is a plain text one, accessible with any text editor; but you are strongly recommended to use DKLang Translation Editor (available on the site) for this purpose since it provides a number of additional, translation-specific features.
  • About 80% rewrite of internal program design. This might affect the number of bugs ;)
  • Undo data are now stored to the disk, not to memory. This allowed to increase the default undo buffer size to 100 operations.
  • Thumbnail window: smooth scrolling; Ctrl+Arrows/PgUp/PgDn/Home/End now moves the focus leaving the selection intact; Shift+Alt+Arrows/PgUp/PgDn/Home/End creates rectangular selection; Space/Ctrl+Space toggles focused thumbnail selection; Ctrl+Mouse wheel scrolls one screen per detent.
  • Enabled file drag'n'drop into the group tree.
  • New resampling filters: Draft (more precise than Nearest neighbor but significantly faster than Bilinear/Bicubic) and Cosine.
  • Additional thumbnail appearance settings: thumbnail background border style and color.
  • A possibility of Picture properties dialog default page selection.
  • A possibility of picture data editing while a view is active.
  • Thumbnail caching in the Browse mode is no longer pertinent. Things showed it caused big problems under Win9x.
  • Pressing the Enter key in the Browse mode when thumbnail window is active starts viewing of the current picture. Pressing Shift+Ctrl+Enter enters the View mode and starts slide show.
  • Pressing the Enter key in the View mode exits back to the Browse mode provided the last viewed picture is selected in the thumbnails window.
  • Tons of minor fixes.
PhoA 1.1.5 beta
[Jun 14, 2004]
  • A possibility for nondestructive picture rotation by multiples of 90° and for horizontal and vertical flipping during viewing. Also the transformations may be stored with the picture in the photo album file. Transformation controls on the View page (now View & Adjust) of Picture properties dialog.
  • New picture group properties: ID (an unique numeric identifier), text description, number of pictures and nested groups; the group properties dialog; options for configuring and displaying the group tooltips.
  • Improved message boxes: there is the Don't show this message again checkbox wherever it is appllicable.
  • A possibility for switching the visual theme for toolbars and the status bar.
  • Pressing Ctrl+Enter in dialogs acts as clicking on OK. This allows for applying the changes when caret is in a multiline edit box.
  • A possibility for autofilling the picture transformations (rotation and flips) according to metadata.
  • File operations wizard: the confirm file overwrite dialog now has also Yes to all and No to all buttons.
  • Splash screen at program startup displaying the current startup status.
  • Options for animating the splash screen and About dialog fadeout.
  • Support for command line keys.
  • View | Remove Search Results menu item.
  • Extended TIFF support.
  • Minor changes and fixes.
PhoA 1.1.4 beta
[May 16, 2004]
  • File operations wizard: options for selecting pictures with existent or nonexistent files on the picture selection page.
  • File masks have been extended: symbol ! at the start of the mask inverts its meaning.
  • Right mouse click when Ctrl is pressed invokes shell context menu for the current file for both browse (click on a thumbnail image) and view (click on image) modes.
  • View window in Always on top mode now doesn't obscure Picture properties and Program settings dialogs.
  • Program settings use inplace editing now. Eg., picture properties to display on thumbnails are now being selected from the dropdown list.
  • Browse mode options Thumbnail background color and Thumbnail font color.
  • View mode option Keep mouse cursor over the toolbar button on window resize.
  • View mode option Show picture info and Show info command in the view mode.
  • Add pictures wizard option Show hidden files and folders.
  • Wizard log pages display record number, total number of records and number of failed entries. Also Copy to clipboard and Find text features implemented.
  • Clipboard options allow to specify which formats are placed into the clipboard on Copy and Cut operations. Possible formats are: PhoA pictures, shell file objects (this allows you to simply copy the necessary files for selected pictures into any folder), plain-text file path list, thumbnail image.
  • Implemented invoking the external programs - tools: Tools page in the settings dialog; a possibility to include additional items in Tools and popup menus.
  • Fixed invoking the help in dialogs with F1 key.
  • Fixed Access Violation when the root group contains pictures and File | New menu item is selected.
  • Fixed display of file sizes over 2 GB in Statistics.
  • New images for buttons, menu items etc.
  • Reorganized documentation.
PhoA 1.1.3 beta
[Mar 29, 2004]
  • New interface language: Ukrainian (translation by Serge Mikulin).
  • File operations Wizard added allowing to perform the following operation with picture files:
    • Copying files of selected pictures into single folder / maintaining original folder layout relatively to specified folder / maintaining picture group hierarchy relatively to specified group (incl. possibility for creating multiple copies of a file when this file is contained in several groups).
    • Moving picture files of selected pictures - with the same options as copying; the moving updates file links in corresponding pictures. There is also option for deleting the original files (wipe or recycle).
    • Deleting files of selected pictures, including corresponding pictures.
    • Rebuilding thumbnails for selected pictures - this operation is also handled by the Wizard.
    Moreover, copying and moving also allow to automatically create a separate photo album for the files being copied or moved, to copy the program executable and to create autorun.inf file - the File operations Wizard makes preparing a CD or DVD a snap.
  • Possibility for storing and loading settings to/from an ini-file. Also option for autoloading settings from phoa.ini on program startup, if this file is present in the program directory.
  • Picture operations dialog displays faster.
  • Add pictures Wizard now remembers last settings used.
  • Toolbar dragging option now affects the View mode toolbar.
  • Possibility for sorting the search results.
  • Minor fixes.
PhoA 1.1.2
[Feb 07, 2004]
  • New interface languages: German (by Dominik Mayer) and Brazilian Portuguese (by Cesar Boschetti). Now PhoA supports 4 languages!
  • Background decoding thread's priority has been lowered. The result is that the picture already decoded is displayed significantly faster.
  • A stupid memory leak removed - the background decoding thread didn't terminate when viewing is finished.
  • Search by picture dimensions bugs fixed. Searching the file mask now checks just the file's name, not its full path.
PhoA 1.1.1b
[Sep 17, 2003]
  • New options for trees/lists: Incremental search on typing and Incremental search cleanup delay.
  • In the Picture properties dialog the first control on the page gets focused automatically.
  • Changes to Picture properties | Metadata: description panel, metatag code is now displayed.
  • Changes to Picture properties | View: wheel scaling is fixed.
  • Changes to Picture properties | Keywords: Checked only switch; new keywords are painted navy only when not highlighted.
  • Changes to Picture properties | Groups: speeded up the first time display.
  • An attempt made to fix font displaying in both Unicode- and non-Unicode-systems for various codepages/charsets.
  • Dialogs have been changed. Fixed large system font issues.
  • EXIF-tags list has been expanded, many tags have got descriptions.
  • Support for "non-regular" metatags: Unicode (WinXP-tags), Versions etc.
  • Fixed issue with PhoA denied to open 0.x version photo albums.
  • Fixed view mode bug: predecoding malfunctioned.
  • Fixed search bug: date, time and keyword searches were not working properly.
  • Fixed some memory leaks.
  • Minor changes.
PhoA 1.1.1a
[Sep 08, 2003]
  • Photo album file format changed - now it is very expandable and meant not to be changed frequently.
  • Modifications to folder tree appearance:
    • Views toolbar has been removed. Instead of it there is now a dropdown button beside the photo album node invoking views menu.
    • Pictures are now can be placed directly to the photo album node, having no group created.
    • Number of images is displayed beside the group name.
    • Altered Drag'n'Drop functioning: to insert a node as a sibling of another node (above or below), you'll have to drag the node to the free area on the right side of nodes, and then the insertion point is drawn as a line. To make a node a child of another node you drag this node right over the target node, then the target node gets highlighted. There's no more Shift button used (i mean while dragging ;)
    • When a node is being dragged the target node expands if you leave mouse over the target for a time. Also when mouse rests near the top or bottom edge (while dragging) the group tree starts to scroll.
    • Cosmetic changes (root items are drawn bold, Drag'n'Drop uses blended source folder image etc.)
    • Lists are adjustable.
  • Picture adding and editing have been completely separated. The goal was to remove compromises in the interface. Pictures are always being added with the defaults, you may edit them afterwards.
  • Changes to the Add pictures dialog:
    • The dialog became the wizard. On the first stage you select picture files and/or folder, on the second one you may exactly determine which files are to be added.
    • When adding pictures you can filter them by photo album presence, by name or extension, by date/time file modified.
    • Picture addition is performed in the separate thread which has improved the response to user actions.
    • Addition process is being logged, the log can be saved to a text file.
  • Fully functional support for JPEG-image metadata EXIF 2.1 - data placed to image files by almost any digicam as well as by modern graphic editors. Metadata can be used for filling some picture properties.
  • Many changes to Edit pictures dialog. In a nutshell:
    • Dialog became multipaged.
    • File properties page allows you to view file properties info.
    • Metadata page displays all the EXIF data contained in JPEG files.
    • View page enables file viewing for any selected file.
    • Data page is just a thing that was Edit pictures dialog + new properties.
    • Keywords page allows you to modify keyword list by adding, removing and editing single keywords for any number of pictures at once.
    • Groups page shows photo album group tree in which you can easily determine groups pictures belong to, or change these belongings.
  • Program settings were extended aloud.
  • You may now reorder pictures inside group using Drag'n'Drop (in the thumbnails pane).
  • Views now support automated sorting the pictures inside each group.
  • Thumbnail pane always selects the first thumbnail by default.
  • Undo history dialog has been removed: now you can undo any number of changes by clicking the dropdown button near the Undo toolbar button or with Edit | Undo history submenu.
  • All other trees displaying picture groups also have been altered - now they all look like the main tree.
  • The status bar displays the total number of distinct pictures in the photo album.
  • Local toolbar in the view mode.
  • Enhanced support for XP themes in toolbars and the thumbnail pane.
  • Lots of fixes, minor changes and new bugs.
PhoA 1.0.2a
[Jun 02, 2003]
  • By a lot of complaints against thumbnail quality there's resampling filtering option to eliminate shrinked picture's fuzziness. Possible filters are: Nearest Neighbor, Linear, B-spline (bicubic), Lanczos, Mitchell. As a side effect, owing to some smoothing of the thumbnail, its size (because of JPEG-compression) reduced by 10 thru 25% (eg, when using B-spline interpolation the decrease is 20-25%).
  • Significantly increased speed of rescaling and scrolling pictures. In the view mode you can also choose any of the resampling filters listed above.
  • Added option for decoding pictures in background: a separate thread is responsible for decoding the next picture while you are watching current one. This technique minimizes time required to advance to the next picture (but requires more memory).
  • Added option for caching-behind viewed pictures, which minimizes time to rewind to the previous picture (but also takes more memory).
  • The support for .gif files was not included. Fixed.
  • Added support for .msk (Paint Shop Pro mask), .tub (Paint Shop Pro picture tube), .pfr (Paint Shop Pro picture frame) file formats.
  • View info painting is completely changed. Now information is always positioned over the picture, optionally on a translucent background, and you can visually position information bar.
  • In multimonitor systems dialog windows were mispositioned. Fixed.
PhoA 1.0.1a
[May 17, 2003]

Huge number of differences resulted in program version and time taken to release it.

  • Views! Completely new picture arranging algorithm. Now you can classify a heap of pictures into folders with minimum efforts. The only requirement is that pictures' properties are properly filled. Possible grouping conditions are: by picture file path, by date (in various ways), by place, by keywords etc. Groupings may be cascaded, ie may be applied one by one, number of groupings is a matter of sanity. The result of the grouping (folder tree along with their pictures) may be easily put into any photo album group, and after then you can tweak them in usual way.
  • Photo album file (.phoa) format has been changed. Photo album files since version 1.0.1a contain views' data, and they are incompatible with the earlier PhoA versions. The program also supports saving files in PhoA 0.x format, which is choosed while saving the file (File | Save as...); accordingly, in this case views are not saved.
  • Sorting now can be performed by any number of criteria; it is organized in the similar way as views' groupings. The list of sorting criteria has been significantly extended.
  • You can now tweak thumbnail tooltips in Browse mode; you can choose which details are displayed.
  • Picture info in View mode is now also more adjustable.
  • Three options on toolbar buttons size (small/middle/large).
  • Massively extended support for picture file formats. Now almost all possible formats are supported (briefly: Windows bitmap (BMP, RLE, DIB), OS/2 bitmap, TIFF, GFI fax, SGI, Autodesk, Truevision Targa, ZSoft Paintbrush, Word 5.x, Kodak Photo-CD, Portable pixel/gray map, Dr. Halo CUT, CompuServe GIF, SGI Wavefront, Photoshop, Paint Shop Pro, Portable network graphic PNG; for details refer to the file formats discussion).
  • New algorithms for keyword processing (keywords containing spaces and/or commas are to be quoted; when selecting them from the list such keywords are quoted automatically; keywords are no longer converted to lowercase in the Select keywords dialog, though keywords are still compared case-insensitively).
  • A number of minor fixes (including fixed Access Violation in some cases while browsing).
PhoA 0.10 beta
[Jan 09, 2003]
  • The fully operational undo engine is built into PhoA.
  • New button "Add all" in the Add picture dialog, allowing unconditional addition of all picture files selected (using defaults).
  • Clipboard functionality implemented (cut, copy, paste).
  • Minor fixes (Browse mode; photo album stats).
PhoA 0.03
[Oct 20, 2002]
  • Completely bilingual version (English & Russian), including Setup program and Help System files.
  • Implemented Slide Show mode.
  • Minor changes.
PhoA 0.02b
[Sep 06, 2002]
  • The first public release.

Photo album file version differences

Photo album (.phoa) file format is being changed as the program is developed. Different photo album file versions differ in the data being saved. The table below describes the differences in photo album file formats.
Program version | Internal format revision | Format name | New features compared to the prior versions
PhoA 1.1.7 beta 0003 PhoA 1.1+ New view property:
  • Picture filter expression.
PhoA 1.1.5 beta 0003 PhoA 1.1+ New picture properties:
  • Picture rotation.
  • Picture flips.
New group properties:
  • Group ID.
  • Group description.
PhoA 1.1.1a 0003 PhoA 1.1+ New picture properties:
  • Picture width.
  • Picture height.
  • Picture time.
  • Picture author.
  • Picture media name/code.
  • Picture notes.
Views:
  • New picture grouping properties: time hour, time minute, author, media.
  • Possibility to sort pictures in the view groups.
PhoA 1.0.1a 0002 PhoA 1.0.x Views:
  • View list.
  • View name.
  • View grouping list.
PhoA 0.02b | 0001 | PhoA 0.x | The first release of the program.

See also:

File formats


License Agreement

This End-User License Agreement (EULA) is a legal agreement between you (either an individual or a single entity) and the author of this Software (DK Software) for the PhoA Software Package, which includes computer software and may include associated media, printed materials, and online or electronic documentation (Software Product).

By installing, copying, or otherwise using the Software Product, you agree to be bound by the terms of this EULA. If you do not agree to the terms of this EULA, do not install or use the Software Product.

Software Product License

All versions of the Software Product are protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties.

The sole property belongs to DK Software. The Software Product may not be duplicated, sold, distributed or utilized in any manner not described herein without the prior written consent of DK Software.

Parties interested in licensing the Software Product for other than personal use should contact DK Software by this e-mail: phoa@narod.ru.

  1. Grant of license
    This EULA grants you the following rights: Installation and Use. You may install and use an unlimited number of copies of the Software Product.

    Reproduction and Distribution
    You may reproduce and distribute an unlimited number of copies of the Software Product provided that each copy shall be a true and complete copy, including all copyright and trademark notices, and shall be accompanied by a copy of this EULA. The Software Product may not be included in any free, shareware or commercial packages or products.
  2. Description of other rights and limitations
    Limitations on reverse engineering, decompilation, disassembly and alteration of the resources in the compiled the assembly. You may not reverse engineer, decompile, or disassemble the Software Product, except and only to the extent that such activity is explicitly permitted by applicable law notwithstanding this limitation.

    Separation of Components
    The Software Product is licensed as a single product. Its component parts may not be separated for use on more than one computer.

    Software Transfer
    You may permanently transfer all of your rights under this EULA, provided the recipient agrees to the terms of this EULA.

    Termination
    Without prejudice to any other rights, DK Software may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such event, you must destroy all copies of the Software Product and all of its component parts.
  3. Copyright
    Except otherwise explicitly noted, all title and copyrights in and to the Software Product (including but not limited to any images, photographs, animations, video, audio, music, text, and applets incorporated into the Software Product), the accompanying printed materials, and any copies of the Software Product are owned by DK Software. The Software Product is protected by copyright laws and international treaty provisions. Therefore, you must treat the Software Product like any other copyrighted material.

Limited Warranty

No warranties

DK Software expressly disclaims any warranty for the Software Product. The Software Product and any related documentation is provided as is without warranty of any kind, either express or implied, including, without limitation, the implied warranties or merchantability, fitness for a particular purpose, or noninfringement. The entire risk arising out of use or performance of the Software Product remains with you.

No liability for damages

In no event shall the author of this Software Product be liable for any special, consequential, incidental or indirect damages whatsoever (including, without limitation, damages for loss of business profits, business interruption, loss of business information, or any other pecuniary loss) arising out of the use of or inability to use this product, even if DK Software is aware of the possibility of such damages and known defects.

Registration

PhoA is a donationware product. It may be used free of charge for any purpose. We ask that donations be made from our website if you can afford to do so. Visit http://www.dk-soft.org for further information.

By using this software, you are agreeing to the terms of this license.

Major Contributors

  • Jordan Russel - TB2000 & InnoSetup
  • Alex Denisov - TBX & Graphics32
  • Mike Lischke - VirtualTree & GraphicEx
  • Jim Kueneman - VirtualShellTools
  • Frank Händle - hosting

    • Copyright ©2002-2005 DK Software. All rights reserved.


Major program modes

PhoA operates in the following two major modes:

  • picture browsing and arranging;
  • picture viewing.


Browse mode

As it was mentioned above, the browse mode is intended for photo album creation. This mode is just one the program starts in.

The main program window looks similar to standard Windows® Explorer: the left pane displays folder-groups tree hierarchy while the right one gives us a list of thumbnails for the group selected in the left pane.

Right to the left of the root tree node - the photo album node you can see a drop-down menu button allowing you to display menu with photo album view commands as well as for switching between views and photo album groups.

It is also possible to use the Space key when the root node is highlighted to display that menu.

See also:

Browse mode menu commands
Working in the browse mode
Working with views


Browse mode menu commands

  • File menu
  • Edit menu
  • View menu
  • Tools menu
  • Help menu

To the left of the photo album node in the folder tree dropdown-menu button is placed, which brings up the view menu.

See also:

Keyboard and mouse controls
View mode
Photo album properties dialog


Browse mode menu commands :: File menu

This menu contains commands for photo album file operations.
Menu Item | Description
New | New photo album creation. This erases all groups, pictures and views, and photo album properties are reset to their defaults.
Open... | Opens a standard File open dialog allowing you to select a photo album file (with the .phoa extension).
Save | Saves the photo album to the file currently open. If this is a new photo album, this item executes Save as... instead.
Save as... | Displays a standard File save dialog to save the photo album into another file.
Save current settings to file... | Displays the Save current settings dialog allowing you to store the current program settings into an .ini file, details.
Load settings from file... | Displays the Load program settings dialog for restoring program settings from an .ini file, details.
Exit | Confirms whether you wish to save changes if there were any (or if it is configured in the Confirmations settings), and then exits the program.
Below follow the MRU (most recently used) file menu items (the number of stored entries is adjusted with Program settings dialog).


Browse mode menu commands :: Edit menu

This menu contains the photo album editing commands, and also commands for switching to the View mode.
Menu Item | Description
Undo operation | Rolls back the changes to the photo album caused by indicated (the most recent) operation.
Undo history | Contains the list of changes made allowing you to roll back a number of sequential changes at once.
Cut | Removes highlighted pictures and places them into the clipboard (you can add them later to another picture group).
Copy | Copies highlighted pictures to the clipboard.
Paste | Adds pictures contained in the clipboard (if any) to the current group. Obviously, you can only add new pictures to a group so any duplicate is skipped. If this is specified in the program settings, PhoA notifies you of number of the pictures actually pasted.
Add group | Adds a new picture group. A group is created as a child to the group currently highlighted. Thus, when the photo album node is highlighted, a group is created in the photo album's root directory. The default group name is "New group", you change it by editing it and pressing Enter.
Add pictures... | Invokes the Add pictures wizard allowing you to add pictures (i. e. files) to the photo album.
Delete
  • When group tree is active: remove the current group.
  • When thumbnail window is active: remove selected thumbnails.
Edit...
  • When the photo album is selected in the group tree (the root node when picture groups are displayed), this items allows you to edit photo album's description or change thumbnail settings in the Photo album properties dialog.
  • When a photo album picture group is selected, this item allows you to rename it, or edit its description (you also can rename a group by clicking once on a selected group text, or by hitting the F2 key. To cancel edit, press Esc; to accept the new group name press Enter).
  • When a photo album view node is selected (the root node when a view is displayed), this item shows the View properties dialog.
  • When thumbnail window is active, this item displays the Picture properties dialog allowing you to view or modify selected picture properties.
Sort pictures... | Arrange (sort) pictures in the current group, or in all photo album groups using the Sort pictures dialog.
Select all | Selects all the pictures in the current group.
Select none | Deselects all the selected pictures.
View | Enters the program into the View mode. You can also enter the View mode by double-clicking a picture, or pressing Enter when thumbnail window is active.
View slide show | Enters the View mode and turns the slide show on.


Browse mode menu commands :: View menu

This menu controls the program window appearance.
Menu Item | Description
Toolbar | Controls visibility of the Main toolbar.
Status bar | Controls visibility of the Status bar.
Flat mode | When Flat mode is active, the thumbnail window shows not only the thumbnails from the group currently selected in the group tree, but also from all its subgroups. Picture reordering by draggin them with mouse is allowed only if the current group doesn't contain subgroups.
Remove Search Results | Hides the Search Results folder.
Below the photo album view menu items follow.
Picture groups | Switches group window display to the basic mode, when the group window shows photo album groups (the default selection).
Below follow the photo album view items. When you select an item the corresponding view is activated, and the group tree displays an automatically built view group hierarchy.
New view... | Opens the Photo album view properties dialog for creating a new view.
Delete view | Removes the currently active view (in a case a view is active).
Edit view... | Displays the Property dialog for editing the currently active view (in a case a view is active).
Make a group... | Opens the Select picture group dialog, allowing you to copy view group hierarchy into a selected photo album picture group.


Browse mode menu commands :: Tools menu

Additional tool commands are collected in this menu.
Menu Item | Description
Program settings... | Invokes the PhoA settings dialog.
Statistics... | Computes and displays various photo album summaries.
Picture operations... | Allows you to move, copy, crop and intersect pictures with another group using the Picture operations dialog.
File operations... | Starts the Picture file operations wizard allowing you to copy, move, delete the picture files, to rebuild the thumbnails or repair the broken picture file links.
Find... | Displays the Find pictures dialog. Refer to this chapter for further information.


Browse mode menu commands :: Help menu

The menu contains PhoA Help System invocation and open program web site commands:
Menu Item | Description
About... | Displays version, copyright, update and contact information.
Help contents | Invokes the PhoA Help System you are currently watching.
FAQ | Shows the PhoA FAQ (Frequently Asked Question) section.
Internet | Check for updates | Starts the default Internet browser and opens the Program update check page.
Internet | PhoA home site | Starts the default Internet browser and opens the PhoA home page.
Internet | Product support | Starts the default Internet browser and opens the Program support page.
Internet | DK Software Website | Starts the default Internet browser and opens the Program vendor page.


Working in the browse mode

The most common tasks were discussed in Browse mode menu commands chapter. I'd like to highlight here more specific PhoA topics.

Picture data

As was mentioned in the lyrical part, the program stores picture list independently (to be precise, this is the list elements of which are links to picture files holding the description, thumbnails etc). The group tree is also being stored independently. Each single group holds a set of links to pictures so when you add a file to the group (you work with pictures only by using files), and the file is already being used and described somewhere in the photo alubm the program automatically finds and fills all the appropriate data fields; similarly, when you edit picture data (eg, place or date), these data change in all occurences of the picture file.

It works slightly different when you remove a picture from a group. If the picture being removed is linked by any other photo album group (or groups), only the link to the picture is removed, and the picture itself remains in the photo album (having other group(s) linked to it); if you once later decide to add the picture file back to the group, PhoA will add just link to the existing picture. When you delete a picture that was linked only in the current group, the picture is wiped away completely so if you later add the picture back, you'll have to fill picture data with your own.

Drag'n'Drop

Obviously, a picture cannot be contained twice in a group. The most simple way to copy picture across the groups is to drag them with the mouse from the right pane (thumbnails area) to a group in the tree (in the left pane) holding the Ctrl key. Dragging and then dropping pictures with no Ctrl pressed results in that pictures move (they are removed from source group and placed into target group). You can drag-and-drop more than one picture at once: you select appropriate pictures before starting the drag operation (using keys Ctrl, Shift and left mouse button) and start dragging with any of selected pictures. After pictures are moved or copied, PhoA informs you of changes made, if it's specified in the program settings (Notifications section).

Additionally, you can drag-ang-drop group folder as well thus rearranging group tree. When you drag a group above free area to the right of the nodes, tree window displays group insertion place being drawn as a line, in this case the group is inserted as a sibling of the target node, just above or below it, depending on mouse cursor location (also influences the insertion line shape). When dragging a group upon a node the node becomes highlighted, and the group becomes a child of the target highlighted node.

NB: The root directory may contain only photo album node, and ordinary groups cannot be inserted beside it.

Similarly you can copy (but not move) pictures from Search Results tree node into any picture group. It is convenient to arrange pictures by date (eg. by year or by month) after you have arranged it by event in another folder (simply search pictures by date range and copy results to an appropriate group).

Besides this, you can reorder pictures in a group also using drag'n'drop: when you drag selected thumbnails inside the thumbnals window, also insertion line is displayed. When you release mouse button all the selected pictures move to the location indicated right in the sequence they were before. And an alternative method for reordering pictures is sorting them.

Clipboard

PhoA supports clipboard operations. For the moment the following clipboard formats are supported:
Name | Description | Operations available
PhoA pictures | An internal program format supporting all the picture properties. | Copy, Cut, Paste
Picture files | A system (shell) file format. Files placed to the clipboard can be pasted into any disk folder in Explorer, or any other program supporting file operations. | Copy, Cut
Picture file paths | A plain text list of full paths to the picture files. The list placed to the clipboard can be pasted in any text editor. | Copy, Cut
Thumbnail bitmap | A regular bitmap image of the thumbnail currently selected. The bitmap is placed into the clipboard only if there's a single picture selected. The image placed to the clipboard can be pasted in any graphic editor. | Copy, Cut (for a single picture only)

You can configure the clipboard formats by using the General program settings.

As described above the most functional format is internal PhoA picture. It allows cutting, copying and pasting any number of the pictures. Data placed to the clipboard contain all the picture properties except their group belongings. This allows moving (or copying) pictures to another group or even another photo album.

There is a limitation regarding inserting pistures to another photo album: the data of existing pictures (being already registered in the photo album with the same picture file name) do not become overwritten with the new ones; ie, let's say, when you paste a picture linked to file C:\Photos\winter-vacation-1812.jpg to the photo album already containing this file, then the picture will only be added to the current group (if it's not there yet). In the case the picture being pasted is already contained in the target group, this picture is simply being skipped. On paste operation completed the program notifies you about the number of pictures actually pasted from the clipboard (is controlled with program settings - Notifications section).

Undo system

By contrast with many similar products, PhoA implements fully-function undo system, allowing you to roll back any operations that has modified the photo album (the only exception is Rebuild thumbnails operation), and also the series of operations - by selecting Edit | Undo or Edit | Undo history menu items respectively. When you select an item from the undo history list all the prior (ie located above in the list) operations are also being undone.

The number of operations you may roll back is specified in the Browse mode program settings. The default value is 100.

Views

Views are an unique technology of automated picture grouping. Refer to Working with views section for details.

See also:

Keyboard and mouse controls
View mode
Working in the view mode


Working with views

Introduction

Photo album views look similar to photo album group tree, the only difference is that groups are being created by you while view's folder hierarchy is built automatically based on picture data as well as on groupings you provide. A grouping is one logical unit of view's organzation, and it may form one or more folder tree levels. When generating view's folder hierarchy, each picture passed through the filter is arranged into some group, which is determined by the view properties to be seen below.

View properties

As you can see in View properties dialog, the view has name, the list of groupings and the list of sortings.

Controls

View name | The name is specified by you, and it reflects the view's content, eg, "By place and date".
List of groupings PhoA supports the following grouping kinds:
  • By picture file path
    Pictures are arranged into folders according to their physical locations.
  • By date year
    Pictures are grouped into folders, each of which contains pictures with the same year. This grouping supports arranging unclassified pictures into a separate folder.
  • By date month
    Pictures are grouped into folders, each of which contains pictures with the same month. Usually it is worth to apply this grouping after the grouping by date year, in this case you'll have year folders containing folders for months of that year; but you may apply this grouping alone, this way pictures will be grouped by the month, but still with different years. This grouping supports arranging unclassified pictures into a separate folder.
  • By date day
    Pictures are grouped into folders, each of which contains pictures with the same day of the month. Usually it is worth to apply this grouping after the groupings by date year and by date month, in this case you'll have year folders containing folders for months of that year, and they in turn will contain folders for days of that month; but you may apply this grouping alone, this way pictures will be grouped by day of the month, but still with different years and months. This grouping supports arranging unclassified pictures into a separate folder.
  • By time hour
    Pictures are grouped into folders, each of which contains pictures with the same hour (taken from picture's time). This grouping supports arranging unclassified pictures into a separate folder.
  • By time minute
    Pictures are grouped into folders, each of which contains pictures with the same minute (taken from picture's time). Usually it is worth to apply this grouping after the grouping by time hour, in this case you'll have year folders containing folders for minutes of that hour; but you may apply this grouping alone, this way pictures will be grouped by the minute, but still with different hours. This grouping supports arranging unclassified pictures into a separate folder.
  • By place
    Pictures are arranged into folders by their place. This grouping supports arranging unclassified pictures into a separate folder.
  • By film number
    Pictures are arranged into folders by their film number. This grouping supports arranging unclassified pictures into a separate folder.
  • By author
    Pictures are arranged into folders by their author. This grouping supports arranging unclassified pictures into a separate folder.
  • By media name or code
    Pictures are arranged into folders by their media. This grouping supports arranging unclassified pictures into a separate folder.
  • By keywords
    Pictures are arranged into folders by their keywords. Accordingly, one picture may participate in some folders, and it'll do if it contains some keywords. This grouping supports arranging unclassified pictures into a separate folder.
List of sortings | After pictures are arranged into folders they reside there, as rule, in random order, and that's inconvenient; moreover, you cannot reorder them manually. To fix this there's a possibility in PhoA to sort grouping results in each group with use of sortings. You do this just like when you sort pictures in the photo album.

Arranging unclassified pictures into a separate folder

As you know, this is not mandatory to completely describe a picture. But since when generating a view each picture passed the filter is processed and included into the view (see above), there are two choices how to handle pictures having no data for the given grouping criteria (no date when grouping by date, no place when grouping by place etc.):

  • If a grouping has "Unclassified pictures in own folder" checkbox checked, they will be put into the appropriate folder ("No date", "No place" etc.) located at the same tree level as the rest of folders, and just at the top of the level.
  • If the checkbox is unchecked, pictures with no data will be leaved in the former folder, and no additional folder is created for them. So, given the grouping by date (checkbox is unchecked), the picture remains in the root folder (the folder corresponding to the view itself), and if you then apply the grouping by place (checkbox is checked), the "No place" folder will reside in the root directory, and the picture will be placed there, while the rest of folders (with place specified) will be created under the date folders; thus picture classification by place will reside on different folder tree levels.

This feature (obvious) is not applicable for the grouping by picture file path since there are no pictures with no files, and there are no files without paths (at least I've heard nothing of it ;).

Picture filter expression

You are able to restrict the list of images placed to the view. You do it using Filter expression editor the way like in Exprssion search. If no filter expression specified, the view will contain all photo album pictures.

Copying view's folders to the photo album

PhoA also introduces the possibility for copying generated folder and picture structure as ordinary photo album groups. For this you select View | Views | Make a group... menu item, then Select a group dialog appears, allowing you to select a group to place view's folders to.

See also:

View properties dialog
Browse mode
Working in the browse mode
Keyboard and mouse controls
Working in the view mode


Autofilling the picture properties

PhoA is capable of automated filling some picture properties. At the moment there are the following autofill capabilities:
Property Autofill possibility
Date
  • From the Original date & time EXIF tag
  • From the Dititized date & time EXIF tag
  • From the Date & time EXIF tag
  • Extraction from the picture file name - if it has yyyy-mm-dd hh-mm-ss.* format
  • From file creation date/time
  • From file modification date/time
Time
  • From the Original date & time EXIF tag
  • From the Dititized date & time EXIF tag
  • From the Date & time EXIF tag
  • Extraction from the picture file name - if it has yyyy-mm-dd hh-mm-ss.* format
  • From file creation date/time
  • From file modification date/time
Transformations
(rotation, flips)
  • From the Orientation EXIF tag

The program will try to fill a particular picture property, iterating through items enabled in dialog settings in the order they are listed. If a property was filled successfully the program stops iterating.

Moreover Overwrite if already specified option also affects autofill.

See also:

Program settings :: Dialogs
Picture data
Metadata
Viewing the metadata
Transformations


View mode

This mode allows you to view single pictures one by one - either in a separate window or in the full-screen mode. And this is probably what you create the photo album for.

In the view mode you can do the following:

  • scale (zoom in and out) the viewed picture;
  • scroll the picture with the mouse or keyboard in a case it isn't fully visible in the window;
  • advance to the next, the previous, the first or the last picture in the current view list;
  • switch between window and fullscreen viewing modes;
  • edit the current picture properties;
  • turning on and off the Slide Show mode;
  • open program preferences & so on.

These functions are available through the Main Menu, the Toolbar buttons, by using the context menu that appears when you right-click the window, or using the keyboard and mouse controls.

See also:

Working in the view mode
Program settings :: View mode
Browse mode


View mode menu commands

  • Picture menu
  • View menu
  • Zoom menu
  • Tools menu
  • Help menu
NB:
  • Most of the menu commands are also available in the view mode context menu invoked by a right mouse click.
  • Clicking with the right mouse button holding the Ctrl key displays a shell context menu (an Explorer menu) for the current picture file.
  • If the main menu is not visible, to display it, select the View | Main menu context menu item.

See also:

Working in the view mode
Keyboard and mouse controls
The Browse mode


View mode :: Picture menu

This menu contains picture advancement and property editing commands as well as command for exiting the View mode.
Menu Item | Description
First picture | Jumps to the first picture in the view list.
Previous picture | Reverts to the previous picture.
Next picture | Advances to the next picture.
Last picture | Jumps to the last picture in the view list.
Edit... | Opens the Picture properties dialog for the current picture, allowing you to edit the picture details.
Close | Ends the viewing session and returns to the Browse mode.


View mode :: View menu

This menu controls the viewing window appearance.
Menu Item | Description
Main Menu | Toggles the view window Main Menu bar.
Main Toolbar | Toggles the Main Toolbar.
Transformations Toolbar | Toggles the Transformations Toolbar.
Slide Show Toolbar | Toggles the Slide Show Toolbar.
Fullscreen mode | Switches between fullscreen and window viewing modes. You can also perform the switching by using the F key or with middle mouse button (wheel) click.
Reload | Reloads the picture currently displayed, from the file. This may appear useful to reload a picture changed externally.
Show info | Shows or hides the picture information bar.
Relocate info bar | Enters the info bar positioning mode, when the info bar has eight drag handles on its bounds and you are able to resize it or change its position by dragging it with the mouse. To finish positioning, select this item again or click somewhere outside the bar.


View mode :: Zoom menu

This menu contains image scaling commands.
Menu Item | Description
Zoom in | Enlarges the image by a value specified in the view mode settings. You can also perform the command with Numpad + or Ctrl+Wheel up.
Zoom out | Shrink the image by a value specified in the view mode settings. You can also perform the command with Numpad - or Ctrl+Wheel down.
Zoom actual | Sets the scale to 100% (or 1:1), when one image pixel matches one screen pixel. You can also perform the command with Numpad /.
Zoom best fit | Sets the scale factor so that image becomes fully visible in the window. You can also perform the command with Numpad *.

NB:
  • Maximum image scale is 8:1.
  • Minimum image scale is 1:10.


View mode :: Tools menu

This menu contains commands for invoking some tool functions.
Menu Item | Description
Slide show | Slide show | Starts or stops the slide show - a mode when the program changes the pictures automatically after a certain interval, and in the specified direction (see below).
Slide show | Forward | Sets the slide show direction to Forward (from the first picture to the last one). In contrast with the setting value, this option affects only the current viewing session.
Slide show | Random | Sets the slide show direction to Random. In contrast with the setting value, this option affects only the current viewing session.
Slide show | Backward | Sets the slide show direction to Backward (from the last picture to the first one). In contrast with the setting value, this option affects only the current viewing session.
Slide show | Cyclic slide show | If this option is on, the slide show loops indefinitely. Otherwise it ends up once the last, or first picture is reached (it depends on the slide show direction). When the slide show direction is set to Random, the slide show never terminates automatically. In contrast with the setting value, this option affects only the current viewing session.
Slide show | Slide show interval | Specifies the time, in seconds, during which to display a picture. In contrast with the setting value, this option affects only the current viewing session.
Transformations | No rotation | Cancels the rotation for the current picture. Doesn't affect the next display of this picture. To apply the rotation permanently, use the Store transformations command.
Transformations | Rotate CW by 90° | Rotates the current picture clockwise by 90°. Doesn't affect the next display of this picture. To apply the rotation permanently, use the Store transformations command.
Transformations | Rotate by 180° | Rotates the current picture by 180°. Doesn't affect the next display of this picture. To apply the rotation permanently, use the Store transformations command.
Transformations | Rotate CCW by 90° | Rotates the current picture counter-clockwise by 90° (or clockwise by 270°). Doesn't affect the next display of this picture. To apply the rotation permanently, use the Store transformations command.
Transformations | Flip horizontally | Applies a horizontal flip (along the vertical axis) to the current picture. Doesn't affect the next display of this picture. To apply the flip permanently, use the Store transformations command.
Transformations | Flip vertically | Applies a vertical flip (along the horizontal axis) to the current picture. Doesn't affect the next display of this picture. To apply the flip permanently, use the Store transformations command.
Transformations | Store transformations | Stores all the transformations applied by the above items of this submenu, to the displayed pictures. The picture afterwards will be displayed having the same transformations applied.
Program settings | Opens the Program settings dialog, the View mode settings page.
Below are the tool items (if any).


View mode :: Help menu

This menu serves to access the PhoA Help System.
Menu Item | Description
Help | Opens a Help topic dedicated to the view mode.


Working in the view mode

The behaviour of the program is completely determined by view mode settings. Some parameters you can also override in the current viewing session. Eg, you can switch between window and fullscreen mode by pressing the F key or with clicking by middle mouse button. In window mode settings specify whether picture is scaled (zoomed in) in case it is smaller than the window, or is it shrinked when it is larger than the window; whether viewing windows is alaways on top of other windows; for both modes you can specify window background color.

Moreover, PhoA is able to display picture information when viewing it (else what is it for?).

You can zoom the picture being viewed in and out with mouse wheel (keeping Ctrl depressed) or with +, -, *, / keys on the numeric keypad. If picture is larger than the viewing window it can be scrolled by dragging it with mouse or with arrow keys (also in conjunction with Ctrl and Shift keys). To learn more on using keyboard and mouse in the view mode refer to this chapter.


Photo Album properties dialog

This dialog allows you to define photo album thumbnail parameters - the dimensions (width and height in pixels) and compression, or quality. Default thumbnail dimensions are 150x150 pixels, quality is 40% max. The greater thumbnail dimensions and the higher quality, the greater photo album file (*.phoa) size is, and vice versa. Too low thumnail quality may make it difficult to recognize picture it represents (colors appear distorted).

You can also enter photo album text description here; the description is stored within the photo album.

NB:
  • After you have changed thumbnail parameters the thumbnails should be rebuilt as those parameters will only affect the newly added pictures. You rebuild the thumbnails using the File operations wizard.
  • Besides the dimensions and compression the thumbnail quality is affected by resampling method being used. To configure resampling use the Browse mode settings (this setting is global for all the photo albums, and changing it also requires rebuilding all the thumbnails).
  • Description length is not limited but it's not recommended to make descriptions over 80 printed pages in length because they are difficult to read.

This operation supports undo

See also:

Browse mode
Settings :: Browse mode


Group properties dialog

This dialog allows for viewing or editing picture group properties.

To display it use the Edit | Edit... menu item when the group tree is focused and one of the groups is highlighted (but not the photo album, a view or Search results group).

Controls

ID | A read-only field. Displays an unique numeric group identifier used internally by the program and similar to a picture identifier. The group is being assigned the identifier automatically when it is created or loaded from a photo album had been created by an older program version (prior to 1.1.5).
Text | Specifies the text (or the name) of the group that is displayed in the tree.
Description | Here you can enter some additional informaton about the pictures contained in the group. The description can be displayed in the tooltips if configured in program settings.
NB: A group can be renamed alternatively by inplace editing the group name. You enter the rename mode with the F2 key or by left mouse click on an already highlighted group name in the browse mode.

This operation supports undo

See also:

Browse mode
Settings :: General


Add pictures wizard

This wizard is to add pictures to the group currently selected (including the root one, ie the photo album itself). If the group is not selected, the add function is disabled.

Wizard pages:

  • File selection
  • Checking the selected files
  • Addition process
  • Addition log

This operation supports undo

See also:

Browse mode
Working in the browse mode


Add pictures wizard :: File selection

Adding pictures starts with selecting the picture files and/or folders containing picture files.

Controls

Files/folders list | You select some items you wish using the keyboard or mouse with Shift or Ctrl keys.
Recurse subfolders | If there are folders selected in the tree, then having this checkbox turned on you add files not only from that folders, but also from all the nested folders.
Advanced | Displays or hides the File selection filter panel, allowing you to narrow file selection by certain criteria (see below).
Photo album presence Allows you to filter picture files on their presence in the photo album:
  • Disregard - the filter is ignored.
  • Only files which are absent at the photo album - only files will be added which are not yet in the common photo album picture list.
  • Only files which are present at the photo album - only files will be added which are already contained in the photo album.
File masks | A filter restricting files being added by their name and/or extension. You write the mask by standard PhoA rules.
File modified time | You can specify limits of date and/or time file modified. This way you can eg select files have been saved before or after a particular date. Empty field means filter is inactive.

Next >>

See also:

Add pictures wizard
Browse mode
Working in the Browse mode


Add pictures wizard :: Checking files

At this page you may opt which files are to be added among ones selected at the previos page by check or uncheck them. By default, all files are checked.

Check can be toggled by mouse or with Space key (in this case checks are inverted for all the highlighted files). Popup menu (invoked by the right mouse click) provides additional options.

NB: This page is displayed provided the default options are used. You may want to disable displaying this page in the dialog settings, then the page will be skipped, and after files/folders selection page the picture adding process will start immediately.

Next >>

See also:

Add pictures wizard
Browse mode
Working in the Browse mode


Add pictures wizard :: Adding pictures

This page is displayed while adding the selected picture files. The program shows picture addition progress and the number of errors occured. You can watch those errors (as well as pictures were added successfully) afterwards on the log page.

Moreover the thumbnail created for the picture last added is displayed.

NB:
  • Picture additiong is performed by a parallel thread; you can interrupt the process only between two pictures being processing, and this slightly slows down the program's response on clicking Interrupt button.
  • You cannot close the wizard window having active picture addition process. You will need to interrupt it using the Interrupt button before you can close the window.
  • Picture addition process performs autofilling the picture data. You can setup the autofill feature in the dialog settings; autofill results can be watched at the log page.

Controls

Interrupt By clicking this button you stop the addition process. The button becomes Continue, and by clicking it you resume the process.

On process completion the program closes wizard window (only when no errors occured and settings specify not to show the log when no errors), or advances to the log page.

Next >>

See also:

Add pictures wizard
Browse mode
Working in the Browse mode


Add pictures wizard :: Addition log

The log displays all the operations performed to the picture files, in sequence. Each file (from selected ones) may be marked either as succeeded, or as failed, the latter case the error encountered message appears next to the file name. In the former case the autofill results described.

Controls

Display errors only | When turned on the log shows only failed entries, otherwise succeeded entries are also shown. The option is convenient when you need to find some errors among a large number of added files.
Save to file... Allows you to write the log to a plain text file.
NB:
  • When saving the log all entries are always written, disregarding the Display errors only checkbox.
  • Failed entries are marked with symbols [!] in the file, while succeeded ones have [+] at the beginning. This allows to easily find errors in the log file unless you use to include these characters in file names.
The popup menu (accessible with right mouse click) provides additional options:
Copy | Copies the line currently selected into the clipboard.
Find... | Displays standard Find text dialog allowing you to search through the log list, eg. for a particular file name.

You can watch the log before all files are added by interrupting the addition process and then clicking then Next button. Afterwards you can go back (by clicking Back) and then resume the process.

This operation supports undo

See also:

Add pictures wizard
Browse mode
Working in the Browse mode


Edit pictures dialog

This dialog is intended for modifying selected pictures. To display it, select one or more thumbnails and click Edit | Edit... menu item or press Alt+Enter keys provided the thumbnail pane is focused.

The window contains several pages switched by the toolbar at its left edge, or by pressing Ctrl+Digit keys:
Page | Shortcut | Purpose
File properties | Ctrl+1 | Viewing general picture files properties
Metadata | Ctrl+2 | Viewing metadata contained in the picture files
View | Ctrl+3 | Viewing the pictures themselves at selected scale
Data | Ctrl+4 | Viewing or editing the picture data
Keywords | Ctrl+5 | Viewing or editing the picture keywords
Groups | Ctrl+6 | Determining or changing the pictures' belongings to the groups

This operation supports undo

See also:

Browse mode Working in the browse mode


Edit pictures dialog :: File properties

The page displays file list of pictures that are selected. If you expand the file name you can see that file's properties (type, size, creation, modification and accessed time etc).

By clicking the right mouse button you can invoke standard Explorer context menu for a file.

Controls

Change file... Displays a standard picture file selection dialog, which allows you to select a file the currently selected picture file update to.
NB: You may opt to expand all the properties in dialog settings.

See also:

Browse mode
Working in the browse mode


Edit pictures dialog :: Metadata

This page displays metadata contained in picture files. Metadata are arranged as tree, you can view them by expanding a file name.

If there are no metadata in the file, the corresponding message appears to the right of its name.

The bottom panel, Description, displays additional information for the selected metatag. This panel is visible by default, but can be closed by clicking the X button on it. To display the panel again, select the corresponding item from the context menu.

NB:
  • You may opt to expand all the metadata in dialog settings.
  • Metadata may be used for autofilling the picture properties when adding pictures to the photo album. This is adjusted also in dialog settings.

See also:

Metadata
Browse mode
Working in the browse mode
Autofilling the picture properties


Edit pictures dialog :: View

Here you can view any of the selected picture at the selected scale. Picture file (if there are more than one picture selected) is chosen from the dropdown list.

Controls

Zoom in | Enlarges picture for value denoted in View settings.
Zoom out | Shrinks picture for value denoted in View settings.
Zoom actual | Set the scale to 1:1.
Fit window | Scales picture so that it fits the window. This is the default.
No rotation | Don't apply rotation to the image when it is displayed.
Rotate CW by 90° | Apply a 90° clockwise rotation to the image when it is displayed.
Rotate by 180° | Apply a 180° rotation to the image when it is displayed.
Rotate CCW by 90° | Apply a 90° counter-clockwise rotation (or 270° clockwise rotation) to the image when it is displayed.
Flip horizontally | Apply a horizontal flip to the image when it is displayed.
Flip vertically | Apply a vertical flip to the image when it is displayed.
NB:
  • These commands are also available from the popup menu appearing on right mouse click.
  • Ctrl+Right click invokes shell context menu (Explorer menu) for the file currently being displayed.
  • Transformation commands are applied to all the selected pictures. If a transformation property (eg. rotation) among the selected pictures, the corresponding transformation buttons (rotation buttons in our case) will be in the unpressed state. If you now decide to apply a rotation the rotation will be the same for all the selected pictures.

Picture panning (in the case the picture is larger than the window) is performed by dragging it with the mouse. Additionally you can use the mouse wheel to zoom the picture.

NB: To speed up picture displaying always Nearest neighbor is used for resampling.

See also:

Browse mode
Working in the browse mode


Edit pictures dialog :: Data

Picture data

This dialog page allows you to edit the most of editable picture data:

  • Date - picture date. Date format is determined from Windows' regional settings. If there are no data about picture date the field remains empty.
  • Time - Picture time. If there no data about picture time leave the field empty.
  • Place - place of picture events. Dropdown list displays all previously entered values.
  • Film nuber or name - number that the film being assigned while processing, or name given to it by you. Dropdown list displays all previously entered values.
  • Frame number - no comments.
  • Author - author's or photographer's name. Dropdown list displays all previously entered values.
  • Description - brief picture description suitable for displaying while viewing.
  • Notes - all data not suitable for other fields.
  • Media name or code - picture file media name (eg CD-ROM number). Dropdown list displays all previously entered values.

More detailed info on picture data is here.

A number of pictures at once

PhoA supports editing picture data for any number of pictures simultaneously. For this page the following simple scheme used:

  • If some property is the same across all the selected pictures, then the corresponding entry field will be of white color (or of window color to be precise).
  • If a property's values differ between selected pictures, the corresponding field will be of gray color (or of 3D-objects' color). If you change this field's data the property will be synced for all selected pictures, and the field will become white. Otherwise the property values will remain unchanged (and different, respectively).

You may search pictures by these data afterwards.

This operation supports undo

See also:

Picture data
Autofilling the picture properties
Browse mode Working in the browse mode


Edit pictures dialog :: Keywords

Each picture maintains a keywords list among its data. As a rule this is a list of persons, subject or events on a photograph.

The advantage of keywords compared to plain text is that you dont have to type them - they can be selected from the list. Moreover, you may want to build a view on them, and watch the line changing year to year (by the way, a highly interesting observation). And finally, the keyword list shows number of images a particular keyword linked to.

Keyword list

This list displays all the keywords encountered in open photo album pictures. Grayed text in the parentheses right to the keyword is a total number of the keyword occurences.

If a keyword is contained in some of the selected pictures the keyword will be checked (fully checked if the keyword is present at all of the selected pictures, and grayed, depending on checkbox style, if the keyword is contained not in all selected pictures), and there will be two numbers in the parens delimited with slash: first one is the number of selected pictures used the keyword, second is a total number of occurences.

If a keyword is contained in none of the selected pictures, the checkbox will remain unchecked.

As long as keywords are compared case-insensitively, the program makes do distinction between qwerty and QwErTy.

You can also add keywords here. For you to distinct between existing and new keywords they are painted differently:

  • Already existing keywords wear a key icon and are drawn using black font.
  • Newly added keywords have an asterisk icon and are drawn with navy font.

Keyword operations

Using this page you may freely alter the keyword list for the selected pictures by using the tool panel buttons.

NB: the same operations are accessible through the popup menu appearing on right mouse click.

Controls

Checked only | When on (the button appears depressed), the list displays only checked keywords, otherwise the whole keyword list is displayed. This switch affects only keyword visibility, and doesn't modify the keyword list itself.
Add | Adds a new keyword to the list, checks it and starts editing it. If you decide not to remove the check when you click OK the keyword will be added to all the selected pictures.
Edit Enters keyword editing mode. Notes:
  • The keyword will be replaced only for selected pictures already having it.
  • If a keyword is contained by none of the selected pictures (the were no keyword checkmark) then the keyword will remain unchanged.
  • If a keyword becomes checked then new keyword will be added to all of the selected pictures not contained old one before.
  • If a keyword becomes unchecked then old keyword will be simply removed from selected pictures containing it.
NB: you can also start keyword editing by clicking with mouse on already selected keyword.
Check all | Checks all the keywords in the list.
Uncheck all | Unchecks all the keywords.
Invert | Toggles checks for all the keywords.
NB: Where is Delete button? There's no Delete button by design: if you want to delete a keyword from the pictures, simply uncheck it.

This operation supports undo

See also:

Picture data
Browse mode
Working in the browse mode


Edit pictures dialog :: Groups

At this page you can graphically view groups that pictures belong to. Moreover you can easily add or remove multiple pictures to or from the multiple groups.

Similarly to keywords changes are being made by toggling the entries' checkboxes, and numbers in parentheses also have the similar meaning: one number means number of pictures in the group; if two numbers are divided by slash then the first is the number of selected pictures in this group, and the second is the total number of pictures in it.

Checkbox also acts like for keywords: if no one of the selected pictures is contained in a group, the the checkbox appears clear. If some of the selected pictures are contained, and the rest are not, the checkbox will be grayed. And if all of the selected pictures are in the group, then the checkmox will be checked.

Feel free to develop this on your own.

NB: you cannot check pictures so that some pictures are completely out of groups - this might requre to delete these pictures, but picture deletion is just different operation. Thus PhoA disables such operation notifying you of the situation.

This operation supports undo

See also:

Browse mode
Working in the browse mode


Sort pictures dialog

This function allows you to reorder pictures in the current group, or in all photo album groups based on their data.

If there's no current group, you may only sort the whole photo album.

Controls

Sort criteria list | Sort order is determined by sort criteria, number of criteria may be arbitrary. Each criterion represents a picture property and a sort direction (ascending / descending). Criteria are being added automatically when you select a property to sort by. To display property list you click a dropdown-button in the first column or Space key when the first column has focus. To toggle sort direction you click direction indicator with mouse or press Space key when the second column has focus. You also can reorder items in the list by dragging them with the mouse or using keys Ctrl+Up and Ctrl+Down.
Reset | Reverts all sort criteria to their defaults.

This operation supports undo

See also:

Browse mode
Working on the browse mode


Picture operations dialog

Operations dialog allows you to perform advanced processing on pictures and one of the photo album picture groups (except current). The operations are:

  • Move selected pictures to highlighted group (the same as dragging pictures into this group);
  • Add (copy) selected pictures to highlighted group (the same as dragging pictures into this group holding Ctrl depressed);
  • Delete selected pictures from highlighted group (excluding; the group will contain all pictures but identical to selected ones);
  • Intersect selected pictures with pictures in highlighted group (the group will contain only pictures identical to selected ones).

The function allows to perform various tasks when arranging photo album contents (eg, you may wish to remove repeated pictures from other group or to copy some pictures from one group to another).

This operation supports undo

See also:

Keyboard and mouse controls
Working in browse mode


Photo album statistics

This function calculates and displays summary information on the photo album, its groups and its pictures, and displays it.

Basic photo album statistics items are:
Name | Description
Photo album file | Photo album file properties are presented similar to picture file properties. Moreover, here you can find Photo album file revision item, displaying version of file loaded.
Number of distinct pictures | Number of distinct pictures in the photo album.
Number of nested groups | Number of groups in the photo album.
Number of pictures in th group | Number of pictures explicitly owned by the photo album (the root node of group tree).
Total number of pictures | Total number of links to the pictures (not needed to be distinct) in the photo album group and all nested groups.
Total number of distinct pictures | Total number of links to distinct pictures in the photo album group and all nested groups.
Total picture files size | Sum of file sizes of pictures in the photo album group and all nested groups.
Average picture file size | Average picture file size from pictures in the photo album group and all nested groups.
Total thumbnails size | Sum of data sizes of picture thumbnails from pictures in the photo album group and all nested groups.
Average thumbnail size | Average thumbnail data size from pictures in the photo album group and all nested groups.
Largest picture file | Name of the picture file having the grestest size from pictures in the photo album group and all nested groups.
Size of the largest file | Size of the file from the previous item.
Smallest picture file | Name of the picture file having the least size from pictures in the photo album group and all nested groups.
Size of the smallest file | Size of the file from the previous item.

If there is a picture group selected in the tree then there follows all items listed above (except file name and number of pictures in the photo album) relative to this group.

See also:

Browse mode
Working in the browse mode


Find pictures dialog

PhoA has a powerful tool for searching pictures. To display Find pictures dialog you select Tools | Find... menu item or press F3 key in the Browse mode.

Controls

Perform search Determines the scope of the search:
  • In the photo album - all the available pictures are searched.
  • In the current group - perform search only among pictures of the group currently selected (disabled if no group selected).
  • In the search results - search the results of previous search (enabled only if there is the Search results folder).
Search criteria PhoA supports the following two search methods:
  • Simple search allows you to specify some picture properties and to check conformity of its values to some conditions.
  • Expressions search allows for writing an arbitrary filter expression, which determines the searching criteria.
Find Starts picture searching. Pictures found in search operation (if any) are put into the Search Results folder which is displayed in the root of the group tree. The Search Results folder implements the same functionality as regular picture group folders except for add and remove pictures.

See also:

Picture data types
Picture data
Working in the browse mode
Keyboard and mouse controls


Find pictures :: Simple search

Simple search allows you to visually construct the picture search criteria based on picture propertrty values.

Controls

Reset | Deletes all the entered criteria.
Delete | Deletes the criterion currently highlighted.
Convert to expression | Compiles an expression for expression search from the criteria already entered, and places it to the expression editor.
Search criterion list You enter search criteria in the criterion table using the following data:
  • Picture property - one of the searchable items from picture data, for which the criterion is entered.
  • Condition - one of comparison conditions, list of possible values depends on property data type.
  • Value - a value to compare picture property with.

To add new criterion simply select a property by clicking the dropdown button in the last (empty) table row.

Use arrow keys no navigate through the table. To expand the dropdown list use Alt+Down keys.

Criterion values may be selected from the dropdown history list.

The program select those pictures that conform to all search conditions at once (so conditions are joined using AND operator).

See also:

Find pictures
Find pictures :: Expression search
Picture data


Find pictures :: Expression search

Expression search is the most powerful picture search capability of PhoA.

Detailed description of search expression language (or picture filter expression language) is given here.

For detailed description of the standard PhoA expression editor read this topic.

See also:

Find pictures
Find pictures :: Simple search
Picture filter expressions


Find pictures :: Data types

According to the picture data chart, PhoA uses the following data types for property values:
Data type | Description & criteria
Integer or Ordinal | An integer value can be compared for equality, inequality etc.
String | Any literal. Searching string or substring is implemented, case insensitive.
Pixel format | Not a searchable type.
Date | Criteria are similar to number ones.
Time | Criteria are similar to number ones.
Size (Width x Height) | Not a searchable type.
String list | It is a list of keywords. Keywords may be entered manually or by clicking "..." button in the entry field from the list. The criteria include the conditions of presence or absence of specified or all the keywords.
Picture rotation | Not a searchable type.
Picture flips | Not a searchable type.

See also:

Search
Picture data
Add pictures wizard
Picture properties dialog


Select keywords dialog

You enter this dialog by clicking on the keyword list button in the Find pictures. The program displays the complete list of keywords used in the photo album - sorted in ascending order.

You select ones you wish to search with.

Controls

Reset Clears all keyword checkmarks.
NB: if a keyword contains spaces or commas it becomes double-quoted because these characters are delimiters.

See also:

Find pictures dialog
Picture keywords
Picture data


View properties dialog

This dialog is for adding views or for editing its properties.

The name serves to learn the purpose of the view; the grouping list and sorting list determine view arranging algorithm; Filter expression allows to specify the picture selection conditions for the view.

For details refer to this section.

See also:

Working in the browse mode


Select photo album group dialog (for view)

This window is used for specifying the group to place view's folder hierarchy to.

The whole folder and picture structure will be copied in the specified photo album group (it also may be the photo album itself). After this, you can arrange and tweak the groups and pictures as you use to.

See also:

Working with views
Working in the browse mode


Tool properties dialog

This window allows you to view or edit a tool properties. To display it, select Edit... menu item on Tools page of the Program settings dialog.

Controls

File masks | Determines files the tool is applicable to.
Kind | Specifies a kind of the tool.
Name | Specifies a menu item caption for the tool. You can mark a character a hotkey by prepending it with an ampersand (&). To include the ampersand itself you'll need to duplicate it.
Hint | The hint is displayed in the status bar. If the string contains pipe character (|) the status bar displays only the text following it while the preceding text is used for toolbar button's tooltip.
Command (application) | Is applicable only for custom action. Specifies an executable file to pass picture file names to. You may use Browse... button to select a file.
Parameters | Specify additional command line parameters being passed to the application.
Window | Determines main application's window state when it starts.
Folder | Specifies working folder of the application. Browse... button simplifies folder selection.
Tool usage | Determines which menus will contain the tool items.

See also:

Tools
Program settings :: Tools
Browse mode
View mode


Picture file operations wizard

This wizard performs a number of picture files related operations. It is invoked from the browse mode by selecting Tools | File operations... menu item, or using Ctrl+R shortcut keys.

The wizard is capable of performing the following tasks:

  • Copying the picture files into a specified folder
  • Moving the picture files into a specified folder
  • Deleting unneeded pictures with corresponding files
  • Rebuilding picture thumbnails

Wizard page descriptions:

  1. Task selection
  2. Picture selection
  3. Destination folder selection
  4. Copy/move options (page 1)
  5. Copy/move options (page 2)
  6. CD/DVD creation options
  7. Deletion options
  8. Operation process
  9. Operation log

See also:

Browse mode
Working in the browse mode


Picture file operations wizard :: Copy picture files operation

Use this operation to get a copy of picture files in a specified folder. The operation provides many options; in particular, it allows preparing a photo album to write onto a removable medium such as CD, DVD etc.

To perform this operation you need to start the Picture file operations wizard and on the Task selection page select Copy picture files to a folder.

The next pages will be:

  • Picture selection
  • Destination folder selection
  • Copy/move options (page 1)
  • Copy/move options (page 2)
  • CD/DVD creation options
  • Operation process
  • Operation log

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Move picture files operation

This operation is basically the same as copy files operation, except for the two points:

  • During the move process picture file links are being changed to the new locations.
  • The user can opt to delete the original files (completely or to the Recycle Bin).

Use this operation to reorganize files in your photo album, eg. to move them into another folder, or onto another drive.

To perform this operation you need to start the Picture file operations wizard and on the Task selection page select Move picture files to a folder.

The next pages will be:

  • Picture selection
  • Destination folder selection
  • Copy/move options (page 1)
  • Copy/move options (page 2)
  • CD/DVD creation options
  • Operation process
  • Operation log

See also:

Copy file operation
Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Delete picture files operation

Use this operation to delete unneeded or broken picture files (obviously, with the corresponding pictures; otherwise those pictures would link to nonexistant files). The wizard allows complete picture file deletion as well as moving them to the Recycle Bin instead.

To perform this operation you need to start the Picture file operations wizard and on the Task selection page select Delete pictures and files.

The next pages will be:

  • Picture selection
  • Deletion options
  • Operation process
  • Operation log

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Rebuild thumbnails operation

You need to rebuild thumbnails each time you change their parameters (which are configured in photo album properties dialog): dimensions, quality or resampling (the latter is adjusted in browse mode settings). In that case you have to build new thumbnails - according to the new parameters. Also this operation is useful when source image files have been changed.

To perform this operation you need to start the Picture file operations wizard and on the Task selection page select Rebuild thumbnails.

The next pages will be:

  • Picture selection
  • Operation process
  • Operation log

See also:

Picture file operations wizard
Picture data
Browse mode
Working in the browse mode


Picture file operations wizard :: Task selection

This wizard page serves for selecting a picture file operation:

  • Copying the picture files into a specified folder
  • Moving the picture files into a specified folder
  • Deleting unneeded pictures with corresponding files
  • Rebuilding picture thumbnails

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Picture selection

This wizard page is intended for selecting the pictures for the operation and is applicable for the following ones:

  • Copying picture files into a specified folder
  • Moving picture files into a specified folder
  • Deleting unneeded pictures with corresponding files
  • Rebuilding picture thumbnails

Controls

Selected pictures | The operation you have selected will process the pictures selected in the thumbnail window. For cases when a group is required for the operation the photo album or view group currently selected is used. This mode is the default when you start the wizard, and thumbnail window has focus and selected pictures as well.
All pictures in the photo album/view | The operation will use all the pictures and all photo album groups (in the case picture groups are displayed) or all view groups (when a view is active).
Pictures in selected groups | You decide which groups and pictures will participate in the operation by checking them in the tree. You can only check the groups which actually contain pictures. This mode is the default when wizard starts and group tree has focus; the group currently selected gets checked immediately (unless it doesn't contain pictures).
Additional options are available in the popup menu accessible with right mouse click or with Shift+F10 shortcut keys:
Check all groups | (or Ctrl+A) Sets check to all the groups having pictures.
Uncheck all groups | (or Ctrl+D) Removes check from all the checked groups.
Invert group checks | (or Ctrl+I) Toggles all groups' check state.

Info line at the bottom of the page displays how many groups and pictures the selection actually contains; also the total size for picture files is displayed.

NB:
  • In a case copy/move options allow file duplication the total size may prove greater than indicated one.
  • The space occupied by a file on the disk is usually greater than its size. You should have this in mind when preparing the files to write onto a removable medium.

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Destination folder selection

This wizard page serves for selecting an operation's destination folder and is applicable for the following operations:

  • Copying picture files into a specified folder
  • Moving picture files into a specified folder

You have to make a folder selection in the tree, or type its name in the edit field.

Controls

Create folder Creates a new folder inside the folder currently selected, focuses it and starts editing its name.
NB: For the copy files and move files operations you are allowed to specify a new, nonexistent folder name - in that case the folder will be created automatically during the operation process.

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Copy/move options page 1

This wizard page configures parameters for the following file operations:

  • Copying picture files into a specified folder
  • Moving picture files into a specified folder

Controls

File arranging
These options determine the way the program places files to the destination folder.
Put all the files into the destination folder This mode places all the files into a single folder - the destination folder.
NB: Please note that it is allowed for files to have the same names. This may cause a conflict when placing them into a single folder.
Maintain original folder layout | In this mode the program arranges all the files duplicating their original folder structure. See below for an example.
Use path relative to | PhoA determines automatically the longest common file path for all the selected pictures, and then places it and all its shortened variants into the list.
An example on placing files maintaining the original folder layout
Consider we have selected the following pictures for copy/move operation:
  • C:\My documents\Photo album\Spring 1812\pic001.jpg
  • C:\My documents\Photo album\Summer 1812\pic002.jpg
  • C:\My documents\Photo album\Autumn 1812\pic003.jpg
  • C:\My documents\Photo album\Winter 1812\pic004.jpg
  • C:\My documents\Photo album\Winter 1812\Moscow\pic005.jpg

The program automatically finds that the longest common path for all the pictures is C:\My documents\Photo album, and places it into the list of possible base folders as well as other valid choices: C:\My documents and C:\; the last choice being added is (none): when you select it the drive letter also becomes a folder inside the destination folder.

Let's assume now we have selected C:\My documents as a base folder, and D:\CD-ROM\Disk1 as a destination folder. Once the operation is complete we'll have the following set of files:

  • D:\CD-ROM\Disk1\Photo album\Spring 1812\pic001.jpg
  • D:\CD-ROM\Disk1\Photo album\Summer 1812\pic002.jpg
  • D:\CD-ROM\Disk1\Photo album\Autumn 1812\pic003.jpg
  • D:\CD-ROM\Disk1\Photo album\Winter 1812\pic004.jpg
  • D:\CD-ROM\Disk1\Photo album\Winter 1812\Moscow\pic005.jpg

The program takes D:\CD-ROM\Disk1 as a start point, and each picture file will have folder Photo album in its path as the path is relative to C:\My documents.

Arrange files into folders maintaining group layout | This mode causes PhoA to arrange files into folders duplicating the existing picture group hierarchy in the photo album or view (depends on what is active at the moment).
Use path relative to group | This list allows you to specify the start group from which the program copies the folder structure. The group most distant from the root (photo album or view), which is the common parent for all the selected picture groups, is selected by default (so if the photo album node itself is selected for the operation, or you have selected the whole photo album, the list will contain the only Photo album item). Also the list is populated with all the parent groups of that group including the ultimate parent of all the groups: Photo album or current view.
Allow multiple copies of the file | As PhoA allows linking a picture to multiple groups, the copy operation maintaining group layout may require to place multiple copies of a file into different folders. If this check box is on the program will act just this way, otherwise the file will be copied only once (into the first folder in traversal path).
Replace unallowed symbols with the char | Specifies a character to replace the unallowed in folder names characters with (these are: \ / : * ? " < > |). E.g. if this char is an underscore _ (by default), and there's a group named Friends/Enemies, then it will have the corresponding folder named Friends_Enemies.

See also:

Copy/move options (page 2)
Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Copy/move options page 2

This wizard page configures parameters for the following file operations:

  • Copying picture files into a specified folder
  • Moving picture files into a specified folder

Controls

If the original file does not exist: Is applicable for Move files operation only and determines the program behaviour when it finds that the source file doesn't exist:
  • Treat as an error - logs the error and skips the picture.
  • Update the link only if the target file exists - if a file found as a target one exists the picture will be linked to it; otherwise the picture will be skipped. This mode is useful in cases you have moved files from outside the PhoA, and wish to restore the valid links. In that case you should specify the folder where new files reside (but take into account their former and new folder structure).
  • Update the link anyway - the link to picture file will be changed disregarding the source and target files existence.
Delete original files | Is applicable for Move files operation only. When on, the successful file copying and link updating will be followed by deletion of the file.
Delete to the Recycle Bin Is applicable for Move files operation only.
  • If this option is off, all the files are being wiped off and cannot be restored.
  • If the option is on, the files are being moved into the Recycle Bin rather than deleted (if this is possible on the given machine).
If the target file already exists Specifies the overwrite mode for existing files:
  • Skip the current picture - if the target file exists the program will consider this an error, log this and leave the file intact.
  • Prompt to overwrite the file - the program will ask you to overwrite the existing file. If you decide not to overwrite the file the picture will also be logged as failed.
  • Always overwrite the file - the file will be overwritten with the new one without any notifications.
CD/DVD options
Set up CD/DVD creation options as well | If on, the Next > button click will cause the wizard to advance to the CD/DVD creation options page, or otherwise the program will start processing pictures (after confirmation, if this is specified in the Program settings).

See also:

Copy/move options (page 1)
Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: CD/DVD creation options

This wizard page allows specifying extended options for CD, DVD and other removable media creation for the following file operations:

  • Copying picture files into a specified folder
  • Moving picture files into a specified folder

Controls

Create a photo album file with selected pictures to | If turned on, the program creates a new photo album based on selected groups and pictures, and places it in the file specified in the next field.
Photo album file name | Specifies the name of the file to save photo album to (with .phoa extension). The currently open photo album file name is used by default.
Photo album description | Allows you to specify the description for the newly created photo album. The currently open photo album description is used by default.
Also include existing views | If on, all the views from the current photo album will be added to the photo album being created.
Copy the program itself to the destination folder | If on, the main program executable (phoa.exe) will also be copied into the destination folder. Since (as it's well known) the program doesn't require to be installed to be run on a machine, it can be executed from any media, including removable ones.
Copy the current program settings to phoa.ini | If on, the current program settings will be saved to phoa.ini file in the destination fodler during copy/move operation. This allows running the program from a removable media keeping all the current settings on any machine (but only if setting autoloading from phoa.ini is not disabled in that machine's settings.)
Create autorun.inf file This option allows to automatically generate autorun.inf file placed in the destination folder. In this case inserting CD-ROM to a computer will cause automatic PhoA startup, and then the program will load the photo album specified above.
NB: Autorun is functional unless this feature is disabled on a machine.
Label the media as Specifies media name that is displayed in My computer. The wizard uses Photo album, or current view name by default.
NB:
  • This field is optional, and can be left empty. My computer will display the media label if this is the case.
  • Media label is displayed unless autorun feature is disabled on a computer.

ATTENTION: all the contents of the folder designated as destionation folder must reside in the root directory of the written disk!

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Deletion options

This wizard page specifies the picture file deletion operation options.

Controls

Delete to Recycle Bin
  • If this option is off, all the files are being wiped off and cannot be restored.
  • If the option is on, the files are being moved into the Recycle Bin rather than deleted (if this is possible on the machine).
NB: All the operations being performed (succeeded or failed) log their results which can be inspected later.

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Operation process

This wizard page shows the operation process state:

  • Thumbnail of the picture being processed
  • Progress bar
  • Count of pictures successfully processed
  • Processing fail count

Controls

Interrupt/Continue This button allows interruption of current operation; in the case clicking Next > button advances to the operation log page. The process has been interrupted can be resumed by a second click on the button.

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Operation log

The log page displays sequentially all the operations performed with the picture files.

Controls

Display errors only | When turned on the log shows only failed entries, otherwise succeeded entries are also shown. The option is convenient when you need to find some errors among a large number of added files.
Save to file... Allows you to write the log to a plain text file.
NB:
  • When saving the log all entries are always written, disregarding the Display errors only checkbox.
  • Failed entries are marked with symbols [!] in the file, while succeeded ones have [+] at the beginning. This allows to easily find errors in the log file unless you use to include these characters in file names.
The popup menu (accessible with right mouse click) provides additional options:
Copy | Copies the line currently selected into the clipboard.
Find... | Displays a standard Find text dialog allowing you to search through the log list, eg. for a particular file name.

You can watch the log before all files are added by interrupting the process and then clicking the Next button. Afterwards you can go back (by clicking Back) and then resume the process.

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture filter expression editor

Expression editor is used to create picture filter expressions in PhoA: for Expression search and in View properties.

Detailed description of picture filter expression language) is given here.

Controls

New | Clears the expression editor contents.
Open... | Displays the standard File open dialog which allows you to load text of expression from a file saved before. The dropdown arrow button displays the MRU (most recently used) file list.
Save as... | Displays the standard File save dialog allowing to select a file to write the current expression to.
Insert property | Displays a menu containing the list of available picture properties. When you select an item, property text is inserted at the current caret position in the expression editor.
Insert operator | Displays a menu containing the list of available operators. When you select an item, operator text is inserted at the current caret position in the expression editor.
Cut | Cuts text currently selected in the expression editor, to the clipboard.
Copy | Copies text currently selected in the expression editor, to the clipboard.
Paste | Pastes text from the clipboard into the expression editor.
Undo | Rolls back the last change made in the expression editor.
Redo | Redoes the last misundone change.
Syntax check | Performs the syntax check of the entered expression and displays a message saying about check results.

The same commands are available in the expression editor context menu displayed by a mouse right click or using Shift+F10 keys.

See also:

Find pictures
Find pictures :: Expression search
View properties dialog
Views
Picture filter expressions


Keyboard and mouse controls

It is possible in PhoA to perform almost any operation by a number of ways: selecting an item in the main menu, clicking a toolbar button (only in the browse mode), by pressing a keyboard shortcut, selecting an item from popup menu, or, finally, with the mouse. Below are keyboard shortcuts and mouse control for the two major modes:

  • Browse mode:
    • Keyboard
    • Mouse
  • View mode:
    • Keyboard
    • Mouse


Controls :: Browse mode :: Keyboard

Shortcut | Action | Description
Alt+Enter | Edit | Invokes Photo album properties dialog, Picture properties dialog, or enters current group name editing mode (depends on current selection).
Alt+Ins | Create group | Creates new group as a child of the group currently highlighted, assigns it the default name and starts editing its name.
Arrow keys | Move selection | Moves highlight along group tree or in picture list (depends on which pane is active).
Ctrl+A | Select all | Highlights all pictures in the current group.
Ctrl+Arrow keys | Move focus | Moves the thumbnail focus leaving the current selection intact.
Ctrl+C, Ctrl+Ins | Copy | Copies pictures currently highlighted to the clipboard.
Ctrl+D | Select none | Removes highlight from all pictures in the current group.
Ctrl+End | Focus last | Focuses the last thumbnail leaving the current selection intact.
Ctrl+Enter | View | Enters view mode for the current picture.
Ctrl+F1 | About | Displays version, copyright and PhoA home site info.
Ctrl+F2 | Picture operations | Opens the Picture operations dialog.
Ctrl+F3 | Sort pictures | Brings up Sort pictures dialog.
Ctrl+G | Picture groups | Display photo album group tree (when a view is displayed).
Ctrl+Home | Focus first | Focuses the first thumbnail leaving the current selection intact.
Ctrl+N | Create new photo album | Erases all photo album info as well as groups and pictures.
Ctrl+O | Open photo album file | Invokes photo album file-open dialog, loads photo album for processing or viewing.
Ctrl+Page Down | Focus page down | Moves the focus one screen down leaving the current selection intact.
Ctrl+Page Up | Focus page up | Moves the focus one screen up leaving the current selection intact.
Ctrl+R | File operations | Starts the Picture file operations wizard.
Ctrl+S | Save photo album file | Stores photo album file currently open to the disk.
Ctrl+Space | Toggle thumbnail selection | Selects or deselects the thumbnail currently focused.
Ctrl+V, Shift+Ins | Paste | Adds pictures from the clipboard to the current group (only if clipboard contains valid pictures placed there by PhoA).
Ctrl+X, Shift+Del | Cut | Cuts pictures currently highlighted into the clipboard.
Ctrl+Z, Alt+Backspace | Undo | Rolls back the last change you have done to the photo album.
Del | Delete | Removes group or pictures currently highlighted after the confirmation (depends on current selection).
End | Last element | Moves selection to the last group/picture (depends on which pane is active).
Enter (when thumbnail window is active) | View | Enters view mode for the current picture.
F1 | Help contents | Runs PhoA Help System.
F2 | Rename | Enters current group or current view name editing mode (depends on current selection).
F3 | Find | Allows you to find pictures by given criteria.
F4 | Program settings | Displays the Program settings dialog.
F8 | Statistics | Calculates and displays the photo album statistics.
F12 | Save photo album to another file | Brings up photo album file-save dialog, writes the photo album to the file selected and makes file the current one.
Home | First element | Moves selection to the first group/picture (depends on which pane is active).
Ins | Add picture(s) | Invokes the Add pictures wizard (pictures will be added to the current group).
Page Down | Next page | Scrolls one screen down.
Page Up | Previous page | Scrolls one screen up.
Shift+Alt+Arrow keys | Rectangular thumbnail selection | Selects a rectangular block of thumbnails (with one corner at previous and another one at next highlighted).
Shift+Alt+Del | Delete view | Removes current view from the photoa lbum.
Shift+Alt+Enter | Edit view | Opens the View properties dialog.
Shift+Alt+G | Make a group | Opens the Select a group dialog to place view's groups to.
Shift+Alt+Ins | New view | Invokes the Add view dialog.
Shift+Arrow keys | Picture range selection | Selects picture sequence (starting at previous and ending at next highlighted).
Shift+Ctrl+Enter | View slide show | Enters the view mode for the current picture and starts the slide show.
Shift+Ctrl+O | Load settings from ini file | Displays Load .ini file dialog you wish to load program settings from.
Shift+Ctrl+S | Save settings to ini file | Displays Save .ini file dialog you wish to save current program settings to.
Shift+End | Select to end | Selects pictures from current through last.
Shift+Home | Select to begin | Selects pictures from current through first.
Shift+Page Down | Select page down | Selects pictures from current through one one screen down.
Shift+Page Up | Select page up | Selects pictures from current through one one screen up.
Space | Select thumbnail | Selects the current thumbnail.


Controls :: Browse mode :: Mouse

Shortcut | Action | Description
Wheel | Scroll | Scrolls the group tree or the thumbnail list (depends on which pane is active).
Ctrl+Wheel | Scroll a screen | Scrolls the group tree or the thumbnail list one screen per detent (depends on which pane is active).
Left button click | Single selection | Selects single group or single picturte (depends on which pane is active).
Right button click | Context menu | Invokes context menu.
Ctrl+Left button click | Multi-select pictures | Selects or unselects single picture.
Shift+Left button click | Select picture range | Selects pictures in sequence (from highlighted to one being clicked).
Ctrl+Right button click | Shell context menu | Invokes shell context menu (Explorer menu) for the picture file being clicked.
Drag with left button pressed in area aside pictures, Alt+Drag with left button pressed | Rectangular selection | Draws rectangular picture selection box.
Shift+Alt+Drag with left button | Add rectangular selection | Unions current selection with rectangular selection box.
Drag selected pictures with left button within the window | Reorder pictures | Moves the pictures selected into the insertion point.
Drag selected pictures with left button to a group | Move pictures | Moves selected pictures from the current group to the target one. Displays message of number of pictures actually moved, if this is specified in the program settings.
Ctrl+Drag selected pictures with left button to a group | Copy pictures | Copies selected pictures from curent group to another one. Displays message of number of pictures actually copied, if this is specified in program settings.
Double click on a group tree node | Collapse/Expand | Collapses or expands tree node.
Double click on a picture | View mode | Enters view mode at the current picture.


Controls :: View mode :: Keyboard

Shortcut | Action | Description
Alt+Enter | Edit | Opens Edit picture dialog for picture currently displayed.
Arrow keys | Scroll picture | Scrolls picture in the given direction (in the case it doesn't fit the window).
Ctrl+Arrow keys | Quick scroll picture | Quickly scrolls picture in the given direction (in the case it doesn't fit the window).
Ctrl+I | Info bar relocation | Displays resizing handles around info-string allowing you to resize or move it. Pressing it twice or mouse click outside the bar finishes this mode.
End | Last picture | Jumps to the last picture in the group.
Enter | Finish viewing on the current picture | Like Esc, returns to the browse mode, but focuses the last viewed picture in the thumbnails window.
Esc | Finish viewing | Returns to the browse mode leaving the last thumbnail selection intact.
F | Toggle fullscreen | Switches between the fullscreen and the window mode.
F1 | Help | Displays the view mode help.
F2 | Display info | Toggles info-string line display.
F4 | Program preferences | Displays the Program settings dialog, browse mode settings page.
F5 | Refresh picture | Reloads current picture from file.
Home | First picture | Jumps to the first picture in the group.
Page Up, BackSpace | Previous picture | Reverts to the previous picture.
Page Down, Space | Next picture | Advances to the next picture.
Pause | Toggle Slide Show | Activates or deactivates automatic timed Slide Show mode. Slide Show parameters are set up in the view mode settings.
Shift+Arrow keys | Fine scroll picture | Slowly scrolls picture in the given direction (in the case it doesn't fit the window).
+ (numeric keypad) | Zoom in | Zooms picture in by the value defined in the view mode settings.
- (numeric keypad) | Zoom out | Zooms picture out by the value defined in the view mode settings.
* (numeric keypad) | Zoom best fit | Scales the picture to best fit the viewing window.
/ (numeric keypad) | Zoom actual size | Displays picture at its actual size (so that one picture pixel corresponds to one screen pixel).


Controls :: View mode :: Mouse

Shortcut | Action | Description
Wheel down | Next picture | Advances to the next picture.
Wheel up | Previous picture | Reverts to the previous picture.
Middle button click, Wheel click | Toggle fullscreen / window mode | Switches between fullscreen and window mode.
Right button click | Context menu | Invokes context menu.
Ctrl+Right button click | Shell context menu | Invokes shell context menu (Explorer menu) for the picture file currently being displayed.
Ctrl+Wheel up | Zoom in | Zooms picture in by the value defined in the view mode settings.
Ctrl+Wheel down | Zoom out | Zooms picture out by the value defined in the view mode settings.
Dragging with the left button pressed | Scroll picture | Scrolls picture in the given direction (in the case it doesn't fit the window).


Transformations

The current PhoA version supports socalled nondestructive transformations ie transformations that do not modify the source image files. Such transformations are being applied immediately before the image is viewed, in the memory.

The specified transformations are applied in the predefined order:

  1. Rotation
  2. Flips (or mirror)

You can apply transformations while viewing or beforehand, in the picture properties dialog. Additionally, you can store the transformations you specify during viewing into the picture properties, by using the Store transformations command.

The transformations stored in the picture properties also affect how the thumbnail is displayed as the same transformations are applied to it.

Rotation

The program allows for rotating the pictures by multiples of 90°. This makes possible eg viewing the images taken with the camera rotated relative to source position.

Flips

The two flip kinds are implemented: horizontal (along the vertical axis) and vertical (along the horizontal axis).

See also:

View Mode
Picture properties :: View & Adjust


Command line parameters

PhoA supports a number of command line parameters. The general format of the command line is as following:

phoa.exe [key1 [key_value1] [key2 [key_value2]] ... ] [photo_album_file],

where:

  • keyN - a character prepended with a dash (-). See below for the list of available keys.
  • key_valueN - a character string specifying the key value. Some keys don't allow values while some do. Hence the rest ones allow optional value.
  • photo_album_file - optional photo album file name which will be loaded after program is started.

Available keys

-w view_name | Activate view view_name. If the key is omitted the program displays picture groups upon start by default. The view is searched case insensitively. Example: -w "By date and place"
-g group_path | Select a group specified by the group_path in the tree. The path for a group is a string similar to OS file path with the difference that it is separated with slash character (/). You may do or do not specify the starting slash as this affects none. You are also allowed to specify both ordinary picture group or a view's group (ie. with using the -w key). If you omit this key the program selects the root item of the group tree by default. The groups are searched by the name case insensitively. Example: -g "Photos by date/2000/January/Morning"
-i pic_ID | Select a picture with specified ID in thumbnail window. If the key is omitted the program selects the first thumbnail in the list by default. Example: -i 418
-v | Enter the View mode upon start. The view mode is allowed only when a there is a picture selected.
-s | Only applicable with -v key. When specified, the program will start the Slide show mode.
-f [1|0] | Only applicable with -v key and specifies whether fullscreen or window mode is used. If you omit this key the program will use the default (current) settings for fullscreen mode. If the key is specified with no value or with value of 1 (one) the fullscreen mode will be forced (for the current session only). If the key is specified with value of 0 (zero), the window mode will be forced (also for the current session only). Examples: -f -f 0
NB:
  • The command line parameters are separated with spaces.
  • If a parameter value or photo album file name contain spaces you need to enclose them in double quotes as in examples above.
  • You can specify the photo album file name anywhere in the command line but make sure the program doesn't consider it a key value. E.g., you may write it at the start of the parameter list or right after the key value (because a key may have only one value).
  • The program displays errors found in command line parameters upon start.


Metadata

Picture files may contain not only the graphic data, but also some additional (textual) data called metadata. Such metadata are placed to files by almost any digital camera, for instance, and contain as a rule date, time, taking conditions (digicam orientation, flash usage, F-number) etc.

These data may be viewed and even edited by some programs afterwards, and in general the represent quite reliable and valuable source of information, which is stored inside the picture file.

NB: The serious and not always obvious problem is that images can be open by any program disregarding whether contain they metadata or not, and also whether support these programs metadata or not - the file format allows this. The point is that you may easily lose these metadata if you open a file by some not-so-smart program just to, let's say, rotate the image for 90°. When you save the file, the metadata are gone, because the file gets overwritten. So use only smart programs!

Starting with version 1.1.1a, PhoA also gets quite cute thus now it supports reading the metadata of EXIF 2.2 specification - the format of metadata for JPEG files. Metadata read can be viewed, and also can be used for autofilling the picture properties (provided the corresponding options set).

Moreover, to contribute to programs become cute and educated I've decided to open sources for EXIF reading routines at PhoA website.


Resampling

Pictures often appear "fuzzy" when scaled to a different size. The fuzziness of an image is controlled by two processes: resampling and filtering.

The filtering processes attempt to smooth (blur) the transformed pixels. When an image is being resampled to a different resolution, there's a need to interpolate the old pixelmap to a new one. This requires some form of image interpolation and a number of interpolation methods can be used. The simpler and faster method, is to use nearest-neighbour function, known as the quick filter. Provided the resolution change is not too great, this is normally perfectly adequate. However, for large upsampling operations, the pixels can appear as large blocks. Equally under large downsampling operations, a phenomenon known as anti-aliasing can occur that makes the image appear fuzzy. In such cases, a more accurate interpolation routine can be used but this requires more time for the image to be processed. The most commonly used filters are nearest neighbor, bilinear and B-spline, in order of accuracy. The full list of filters implemented in PhoA follows:

  • Nearest neighbor;
  • Draft;
  • Linear (bilinear);
  • Cosine;
  • B-spline (bicubic);
  • Lanczos;
  • Mitchell.


File masks

File masks are patterns written by special rules.

PhoA uses file masks in a number of places: in search dialog, for filtering the picture files being added, for describing the tools etc.

File masks rules

  • The program implements mask lists, delimited with a semicolon (;). The rules are described below. A file matches masks if it matches any of the masks in the list (logical OR condition).
  • A valid mask (each of the elements of the list delimited with ";") consists of optional negation symbol, literal characters, sets, and wildcards.
  • Negation symbol is an exclamation point (!), placed at the start of the mask. If it is present the mask's meaning is inverted, ie matching files become non-matching and vice versa. Each mask in the list may have or have no negation, each negation affects only the mask immediately following it.
  • Each literal character must match a single character in the string.
  • Each set begins with an opening bracket ([) and ends with a closing bracket (]). Between the brackets are the elements of the set. Each element is a literal character or a range. Ranges are specified by an initial value, a dash (-), and a final value. Do not use spaces or commas to separate the elements of the set. A set must match a single character in the string. The character matches the set if it is the same as one of the literal characters in the set, or if it is in one of the ranges in the set. A character is in a range if it matches the initial value, the final value, or falls between the two values.
    If the first character after the opening bracket of a set is an exclamation point (!), then the set matches any character that is not in the set.
  • Wildcards are question marks (?) or asterisks (*).
    A question mark matches a single arbitrary character.
    An asterisk matches any number of arbitrary characters.
NB:
  • All character comparisons in masks are always case insensitive (ie there is no difference between uppercase and lowercase letters).
  • In places where it is allowed, an empty mask (a mask containing no characters) matches any file.

Sample masks

  • * - any file;
  • *.* - any file having an extension;
  • *.jpg - a file with any name and .jpg extension;
  • vacation.* - a file named vacation and with any extension;
  • [a-z]*.jpg - a file with the name starting with a letter and .jpg extension;
  • [!a-z]* - a file with the name not starting with a letter
  • *.jpg;*.gif;*.png;!temp* - all files having extension .jpg, .gif, .png, and also files with name not starting with "temp".

See also:

Search
Tools


Picture filter expressions

Picture filter expressions are used for Expression search, in View properties and allow you to specify search criteria of an arbitrary complexity using special language similar to modern programming languages.

For editing expression PhoA provides the standard expression editor.

Filter expression language description

Filter expression language is case-insensitive; filter expression can be of arbitrary length and can occupy an arbitrary number of lines.

Filter expression must return a logical (or boolean) value: True or False. If an expression evaluates to True, the picture is assumed matching the filter; otherwise it is discarded.

Filter expression is written using the following elements: picture properties, operators, parentheses, constants, comments.

Picture properties

Picture properties are always start with $ symbol and correspond to actual picture data which are replaced for them during the filtering (or search):
Name | Data type | Property
$ID | Integer | Picture ID (an unique identifier of the picture)
$FileName | String | Picture file name
$FullFileName | String | Picture file name with full path
$FilePath | String | Picture file path
$FileSize | String | Picture file size
$FileSizeBytes | Integer | Picture file size in bytes
$PicWidth | Integer | Picture width in pixels
$PicHeight | Integer | Picture height in pixels
$PicDims | Size (dimensions) | Picture dimensions in pixels
$ThumbWidth | Integer | Thumbnail image width in pixels
$ThumbHeight | Integer | Thumbnail image height in pixels
$ThumbDims | Size (dimensions) | Thumbnail image dimensions in pixels
$Format | Pixel Format | Image pixel format
$Date | Date | Date
$Time | Time | Time
$Place | String | Place
$FilmNumber | String | Film number or name
$FrameNumber | String | Frame number
$Author | String | Author
$Description | String | Description
$Notes | String | Notes
$Media | String | Media name or code
$Keywords | String List | Picture keywords
$Rotation | Rotation | Picture rotation
$Flips | Flips | Picture flips

Operators

Operators can be of the two types:

  • Unary operators are operators having single operand placed on the right side of it.
    Examples: not, isEmpty.
  • Binary operators are operators having two operands on left and right sides of it.
    Examples: and, contains, >.

Operators can be applied only to operands which are of a datatype compatible with the given operator.

Current program version implements the following operators:
Name | Type | Syntax | Description and examples
and | Binary | expression1 and expression2 | Logical AND. Returns True only if both expression1 and expression2 are True; otherwise returns False. Example: $Author='John Smith' and $Date>'Apr 01, 2001'
or | Binary | expression1 or expression2 | Logical OR. Returns True if any of expression1 or expression2 is True; otherwise returns False. Example: $Place contains 'dom' or $Description='freedom'
not | Unary | not expression | Logical negation. If expression is True returns False and vice versa. Example: not ('parrot' in $Keywords)
in | Binary | element in list | Checking of existence of an element in a list. Returns True if element is in the list; otherwise returns False. Example: 'parrot' in $Keywords
startsWith | Binary | string startsWith substring | Returns True if string starts with substring; otherwise returns False. Example: $Place startsWith 'city'
endsWith | Binary | string endsWith substring | Returns True if string ends with substring; otherwise returns False. Example: $Place endsWith 'dom'
contains | Binary | string contains substring | Returns True if string contains substring; otherwise returns False. Example: $Description contains 'crocodile'
isEmpty | Unary | isEmpty list | Returns True if list is empty (contains no elements); otherwise returns False. Example: isEmpty $Keywords
= | Binary | expression1=expression2 | Returns True if expression1 value is equal to expression2 value; otherwise returns False Example: $PicWidth=1024
<> | Binary | expression1<>expression2 | Returns True if expression1 value is not equal to expression2 value; otherwise returns False. Example: $Notes<>''
< | Binary | expression1<expression2 | Returns True if expression1 value is less than expression2 value; otherwise returns False. Example: $ThumbWidth<$ThumbHeight
<= | Binary | expression1<=expression2 | Returns True if expression1 value is less than or equal to expression2 value; otherwise returns False. Example: $ThumbWidth<=100
> | Binary | expression1>expression2 | Returns True if expression1 value is greater than expression2 value; otherwise returns False. Example: $ThumbWidth>$ThumbHeight
>= | Binary | expression1>=expression2 | Returns True if expression1 value is greater than or equal to expression2 value; otherwise returns False. Example: $ThumbWidth>=100

Parentheses

Parentheses are used for grouping parts of the expression, or to change the evaluation order. Expressions can contain only round brackets: ( and ). Example:
not (isEmpty $Keywords or ($Author startsWith 'John') or ($Description='' and $PicWidth=$PicHeight))

Constants

Constants in the expressions can be of the following types:

  • Integer constants contain digits 0...9 and an optional "minus" (-) sign. Example:
    -123
  • Real constants contain digits 0...9, symbol - and a decimal point (.). Example:
    -123.45
  • String constants or literals are enclosed with single quotes (') and can contain any characters. If you need to insert a single quote inside a literal, you should double it. Example:
    'Mary had a little lamb'
    'Don''t get me wrong'
  • Date constants are written in the same way as literals but their format must conform to the current regional settings of your system. Example:
    'Jul 25, 2003'
  • Time constants are written in the same way as literals but using format "Hours:Minutes" or "Hours:Minutes:Seconds". Example:
    '12:00:03'

Comments

Comments are ignored when expression is parsed. They are used for describing and explaining expression blocks or to temporarily "disconnect" an expression block. The following comment kinds are supported:

  • Stream comment {comment}: all the symbols starting with first occurence of { and ending with first occurence of } are considered to be a comment. Example:
    $Date>'01.01.1914' { my grandma birth-date } or $Author<>'grandma'
  • Line comment //comment: all the symbols from // up to line end are considered to be a comment. Example:
    $Date>'01.01.1914' // my grandma birth-date
    or $Time<'08:00'

See also:

Find pictures
Find pictures :: Simple search
Find pictures :: Expression search
Picture data


Tools

A tool in PhoA is an user-defined (and user-configurable) command. Tools introduce the following features:

  • They may be of various kinds.
  • They are applicable to files matching the specified masks.
  • They are displayed in menus; in which exactly depends on tool usage flags set.
  • They are available only when there are pictures selected.
  • They have a name and a hint (except separator item). The name is used as a menu item caption while the hint is displayed in the status bar when you select that item.

Tool kinds

PhoA currently supports the following tool kinds:

  • Separator item
  • Default action
  • Standard Open action
  • Standard Edit action
  • Standard Print action
  • Custom action

Separator item

A separator is a static horizontal divider in the menu.

Default action

Executes an action associated with the file the tool is applied to by default.

Standard Open action

Executes open action associated with the file the tool is applied to.

Standard Edit action

Executes edit action associated with the file the tool is applied to.

Standard Print action

Executes print action associated with the file the tool is applied to.

NB: You can configure the default action and standard actions by Folder options dialog accessible from Windows Explorer Tools menu (File types tab).

Custom action

You specify the application and its parameters using Tool properties dialog by yourself.

File masks

A tool is only accessible (and visible, as with separator item) when all the selected pictures match its masks - if even a single file doesn't, the tool becomes hidden. This behaviour allows to configure tools to process only the files of particular type.

You can learn about file mask rules here.

NB: An empty mask (a mask containing no characters) matches any file.

Tool usages

PhoA tools can be displayed in a number of menus. You configure by yourself where exactly tool action item appears:

  • In Tools menu: the item is displayed in Tools submenu of main menu.
  • In Picture Groups popup menu: the command appears in group tree context menu, which is accessible with right mouse click.
  • In Thumbnails Window popup menu: the command appears in thumbnail viewer context menu, which is accessible with right mouse click.
  • In View mode popup menu: the tool appears in context menu, which is accessible with right mouse click in View mode.

If Group Tree pane was active when you invoked a tool, the tool is applied to all pictures in the group. If Thumbnail Window was active, the tool is applied to selected pictures only.

The order of tool menu items is determined from their order in Tool editor list.

See also:

Program settings :: Tools
Program settings


FAQ (Frequently Asked Questions)

Contents

  • I have read and understood all the program documentation. But how in a hell do I create a photo album?
  • How to switch to another interface language?
  • How do I change default thumbnail dimensions?
  • How can I enhance thumbnail quality?
  • Is it possible to write my photo album to a CD-ROM along with the program so I can view it on any computer?
  • How do I write autorun.inf file for the photo album on a CD-ROM starts automatically?
  • I want the program to open my photo album automatically when I start it. How?
  • Is it possible to alter picture file paths?

Q&A

I have read and understood all the program documentation. But how in a hell do I create a photo album?

Take it easy, all you have to do:

  • You can create some folders (groups) for pictures. You do it by selecting Edit | Add group menu item or by pressing Alt+Ins shortcut keys - then the group is created "inside" the group currently selected. You may skip this step and add pictures directly to the photo album.
  • Highlight a folder to add pictures to (group or the photo album node).
  • Select Edit | Add pictures... menu item, Add pictures Wizard opens.
  • At the first page you select a folder with pictures. Check the checkbox Recurse subfolders if it contains nested folders with pictures. Click Next >.
  • At the Check files page you can choose exactly which files are to be added to the photo album. All the files are checked by default. Click Next >, and the adding process will start.
  • After adding has finished the program closes Wizard window and you see your pictures, or advances to the Log page (click Close if this is the case) - according to the program settings.
  • Save photo album to a file. That's all!

Top

How to switch to another interface language?

The default interface language is determined by the language used during program installation. You can change it by selecting Tools | Program settings... menu item -> General page -> Interface language.

Top

How do I change default thumbnail dimensions?

Each photo album can have its own thumbnail dimensions. These data are stored along with the photo album; you can alter it by selecting the photo album node in the group tree, and then selecting Edit | Edit... menu item.

Top

How can I enhance thumbnail quality?

Thumbnail quality is affected by the two factors:

  • Resampling filter used. Nearest Neighbor is the most quick one but images downsampled with it appear "fuzzy". The most soft contours are achieved by using B-spline, then Linear filters. You get more plain lines with Lanczos filter. To change resampling filter, select Tools | Program settings... -> Browse mode -> Resampling filter.
  • Compression level. Thumbnails are stored in JPEG format; this format compresses images with the price of some quality loss. You can change "size/quality" ratio for each photo album individually, by selecting photo album node in the group tree, and then Edit | Edit... menu item.

Top

Is it possible to write my photo album to a CD-ROM along with the program so I can view it on any computer?

Yes, it is. PhoA has been designed specially so as photo albums can be written onto a removable media together with the viewing tool itself:

  • Photo album files store relative links to picture files, whenever possible (relative to photo album file). Absolute linkage is used for pictures residing on a drive other than photo album's one, or on network drives. This allows writing photo album and pictures on a removable disk provided their relative position is unchanged. E.g.:
    • Before writing: photo album file: C:\My documents\Photos.phoa; base picture files folder: C:\My documents\Pics
    • After writing (onto a CD-ROM): photo album file: D:\Photos.phoa; base picture files folder: D:\Pics
  • PhoA doesn't require any additional files to run besides the main executable phoa.exe. You can place it in any folder on the CD.
  • For the program to load a given photo album, specify its path in the command line, eg: phoa.exe Photos.phoa
  • The most simple and efficient way to prepare the files and the photo album for writing onto a removable medium is using the Copy files operation.

Top

How do I write autorun.inf file for the photo album on a CD-ROM starts automatically?

The basic autorun.inf usage is like the following (you create it using any text editor, then place it into the root CD-ROM directory):

[autorun]
open=phoa.exe Photos.phoa
icon=phoa.exe,1
label=My photo album
This example assumes both program executable (phoa.exe) and photo album file (Photos.phoa) reside in root directory of the CD (so the autorun.inf does).
icon= line specifies a file containing icon to display in "My computer", and icon index (zero-based) in that file. For phoa.exe:
0 - the program's icon;
1 - photo album file's icon.
label= line specifies a drive label to display in "My computer". Refer to MSDN documentation for details.
NB: It is possible to use the autorun.inf creation feature of the Copy files operation.

Top

I want the program to open my photo album automatically when I start it. How?

You should start the photo album file itself, not the program. Eg. put a shortcut to your photo album C:\My documents\Photos.phoa, onto the Desktop, so when you execute it PhoA will start first, then the program will load this photo album.

Top

Is it possible to alter picture file paths?

Firstly, you are able to move picture files together with the photo album file provided their relative placement is unchanged (see writing to a CD).
Secondly, you can move picture files by using the Move files operation.
And thirdly, you may change picture file immediately using Change file... button on File properties page of the Picture properties dialog.

Top


Program settings

This dialog allows you to alter various program settings. To display it, select Tools | Program settings... menu item, or press F4 shortcut key.

The window contains a number of pages switchable with the buttons at the left, or by using Ctrl+Digit shortcut keys:
Page | Shortcut | Purpose
General | Ctrl+1 | General program settings
Browse mode | Ctrl+2 | Browse mode related settings
View mode | Ctrl+3 | View mode related settings
Dialogs | Ctrl+4 | Dialog windows and Wizard settings
Tools | Ctrl+5 | Tool editor

See also:

Browse mode
View mode
Tools
Storing the program settings in a file


Program settings :: General

User interface
Interface language | Common program interface language.
Main program font | Base font used for all PhoA windows.
Visual theme | Allows you to choose a visual theme for toolbars and the status bar.
Tooltip display length | Time to display tooltips in milliseconds.
Recent open files list count | Number of files being remembered in the File menu and Open... toolbutton dropdown list.
Clipboard
Clipboard copy formats | The set of check boxes allows you to configure formats used for clipboard operations.
Toolbars
Main toolbar button size | Determines the size of the main (browser) toolbar buttons.
Toolbar dragging style | Determines the toolbar dragging and docking behaviour.
Trees/Lists
Animated expanding/collapsing | If on, expand and collapse operations appear animated.
Panning using mouse wheel click | If on, the mouse wheel click enters autopanning mode.
Center selection in view | If on, the program will try to center the selected item in the list window.
Incremental search on typing | If on, the selection in lists automatically advances to a node when you type its text.
Incremental search cleanup delay | Specifies the time, in milliseconds, during which the sequential keypresses are assumed to be the same cycle of incremental search.
Collapse/expand button style | Allows you to choose style of tree buttons (only on non-WindowsXP-systems).
Node checkboxes style | Allows you to choose kind of check images (only on non-WindowsXP-systems).
Multiple selection rectangle style | Allows you to choose style of multiselection rectangle used in lists (only on non-WindowsXP-systems).

See also:

Program settings :: Browse mode
Program settings :: View mode
Program settings :: Dialogs
Program settings :: Tools
Storing the program settings in a file


Program settings :: Browse mode

Picture group trees
Tooltips Configures usage and appearance of tooltips in the trees displaying picture groups:
  • None - tooltips disabled.
  • Display if item is truncated at window edge - highlights the item not fitting into the window so that you are able to view it whole.
  • Display with selected properties - the tooltips contain group properties you select (see below). Additionally, the photo album description is displayed for the photo album node when you hover it.
Display in tooltips | The list of group properties to select from. Applicable only if tooltips use the Display with selected properties mode.
Thumbnail view window
Background color | Determines the thumbnail pane background color.
Thumbnail background color | Determines the background color for single thumbnails.
Thumbnail font color | Determines the font color for thumbnail labels.
Drag'n'Drop | Enables or disables drag'n'drop operations with the thumbnails.
Show thumbnail tooltips | This function enables pop-up tooltips for thumbnails when mouse stays still over a thumbnail for a time. The tooltips display picture properties as configured below.
Display in tooltips | The list of properties from which you can choose those to display in thumbnail tooltips.
Picture details displayed on the thumbnails | By using these options you can select whether to display, and which picture properties in each thumbnail corner.
Thumbnail background border style | Determines the style used to draw the frame of the thumbnail background rectangle.
Thumbnail background border custom color | When the option Thumbnail background border style is set to Custom color, the value of this setting is used to draw the frame of the thumbnail background rectangle.
Show thumbnail shadow | If on, a shadow is painted behind the thumbnail image using the settings below.
Shadow blur radius | The radius of a blur used for painting the thumbnail shadow, in pixels.
Horizontal/vertical shadow offset | Offset of the thumbnail shadow relative to the thumbnail image, in pixels.
Shadow color | A color used to paint the thumbnail shadow. The default is black.
Shadow opacity | A value ranged 0 to 255 specifying the opacity of the thumbnail shadow.
Resampling filter | Determines interpolation filter used for resampling source images when creating thumbnails.
Max. undo count | Determines the size of undo buffer used to roll back changes done to the photo album. You can undo no more than specified number of sequential changes (when undo buffer gets full, the least recent changes' data are unrolled). Large buffer requested may result in large need of room (memory) to store it (the most memory-consuming operations are picture deleting and editing).

See also:

Program settings :: General
Program settings :: View mode
Program settings :: Dialogs
Program settings :: Tools
Storing the program settings in a file


Program settings :: View mode

View window always on top | Does not allow the window to fall behind other windows when it's inactive. Affects only the window mode.
Fullscreen mode | When entering view mode the program will set up the fullscreen mode when all other screen elements are hidden (including the Taskbar). This can be overriden with the F key or by clicking middle mouse button.
Keep mouse cursor over the toolbar button on window resize | If on, the mouse cursor stays at the same point of the viewer toolbar when the window resizes. This allows you to click buttons (such as Next picture or Zoom out) multiple times without having to move the mouse.
Hide mouse cursor in fullscreen | When entering fullscreen mode the program will turn off mouse pointer.
Window background color | Determines color for filling the viewing window background. The default is black.
Show toolbar | Enables or disables view mode toolbar.
Picture advancing
Fit window to image | Resizes window so that it fits the picture (considering current scale). Affects only the window mode.
Center window on the desktop | Places viewing window in the center of the desktop. Affects only the window mode.
Shrink image to fit | If a picture is larger than the viewing window, it will be proportionally reduced (to fit the window).
Zoom image to fit | If a picture is smaller than the viewing window, it will be proportionally enlarged (to fit the window).
Cyclic viewing | If on, the viewing sequence wraps around.
Predecode next picture in advance | This option enables background picture decoding thus allowing quick advancing to the next picture (next picture is being decoded while viewing current one). This mode requires more memory for storing predecoded image data.
Cache behind viewed pictures | If this option is enabled, last viewed picture is not removed from the memory thus allowing you to quckly revert to previous picture. This mode requires more memory for storing cached image data.
Scale by | Determines the one step of scaling change (with + and - keys on numeric keypad or with mouse wheel when Ctrl depressed).
Display in window caption | Allows you to choose which picture properties are to be displayed in the window caption bar.
Picture resampling filter | Determines interpolation filter used for resampling (scaling) source images when viewing them.
View info
Show picture info | Enables or disables displaying the information from the properties described below. Can be overriden in the view mode by pressing the F2 key.
Picture properties | Specifies which picture properties will be shown in the view mode.
Font | Determines which font will be used for drawing the picture info.
Background color | Specifies the color of information bar background. See the next option.
Background opacity | Value ranging from 0 (transparent) to 255 (opaque). Allows to adjust the translucence of information bar background.
Slide show
Display time | Determines time intervals (in milliseconds) between picture changes in Slide Show mode (this mode is activated by pressing the Pause key in the view mode, with the toolbar button or by context menu).
Cyclic | When on, PhoA automatically rewinds to the first picture in the group after showing the last in Slide Show mode, else Slide Show is deactivated once the last picture is reached.

See also:

Program settings :: General
Program settings :: Browse mode
Program settings :: Dialogs
Program settings :: Tools
Storing the program settings in a file


Program settings :: Dialogs

Show splash screen at startup | If on, a splash screen is shown at program startup.
Animate startup splash fadeout | If on, the startup splash screen will fadeout slowly after the program is idle (only under Windows 2000 and later).
Animate About dialog fadeout | If on, the About dialog will fadeout slowly when being closed (only under Windows 2000 and later).
Confirmations
Before group deletion | If on, the program confirms before a group is deleted.
Before picture deletion | If on, the program confirms before selected pictures are deleted.
Before view deletion | If on, the program confirms before a view is deleted.
Before saving file of an older version | If on, when saving file of a version older than the current, the program warns you about possible data loss.
Before exit (when photo album is not modified) | If on, the program confirms before exiting even if the photo album isn't modified (if the photo album is modified the program always confirms exit).
Notifications
After copying pictures using Drag'n'Drop | If on, after copying pictures the program notifies you about number of pictures actually copied.
After moving pictures using Drag'n'Drop | If on, after copying pictures the program notifies you about number of pictures actually moved.
After pasting pictures from the clipboard | If on, after pasting pictures the program notifies you about number of pictures actually pasted.
Add pictures wizard
Always skip 'Check files' page | If on, after selecting files/folders in the Add pictures wizard PhoA will start picture addition process immediately.
Show log page only if errors occured | If on, addition log will be displayed only if there were errors, otherwise the wizard window will close right after addition process is finished. If off, the log will be displayed each time upon completion.
Automatically fill picture date from: | Adjusts properties from which to autofill picture date for pictures being added.
Overwrite date if already specified | Tells the program to autofill picture date (overwrite date) even if the date is already entered.
Automatically fill picture time from: | Adjusts properties from which to autofill picture time for pictures being added.
Overwrite time if already specified | Tells the program to autofill picture time (overwrite time) even if the time is already entered.
Automatically fill picture transformations from metadata | Will apply the required transformations to the picture during the autofilling properties for pictures being added. The need for transformations is determined from the Orientation metatag.
Picture properties dialog
Page displayed by default | Specifies the default page to display when you open the Picture properties dialog.
Expand file properties on display | If on, the file properties on the property page fully expand when displayed.
Expand image metadata on display | If on, the image metadata on the metadata page fully expand when displayed.
Picture file operations Wizard
Confirm Copy files operation | If on, the program will confirm proceeding with the Copy files operation.
Confirm Move files operation | If on, the program will confirm proceeding with the Move files operation.
Confirm Delete files operation | If on, the program will confirm proceeding with the Delete files operation.
Confirm Rebuild thumbnails operation | If on, the program will confirm proceeding with the Rebuild thumbnails operation.
Confirm Repair file links operation | If on, the program will confirm proceeding with the Repair file links operation.
Show log page only if errors occured | If on, file operation log will be displayed only if there were errors, otherwise the Picture file operations wizard window will close once the operation is complete. If off, the log will be displayed each time upon the completion.

See also:

Program settings :: General
Program settings :: Browse mode
Program settings :: View mode
Program settings :: Tools
Storing the program settings in a file


Program settings :: Tools

Tools page of Program settings dialog is intended for configuring the set of available tools.

The order of tools in the list determines their order in menus.

You can reorder tools by dragging them with the mouse, using popup menu commands, or with Ctrl+Up, Ctrl+Down keys.

To display tool's menu click the item button, right click the item or press Space key.

To delete a tool select Delete from the tool menu or press Del key.

To view or edit tool properties use Edit... tool menu item, press Alt+Enter shortcut keys or double click an item. This invokes Tool properties dialog.

To add new tool entry select Edit... tool menu item for the last, empty list entry.

Column selection

It's up to you to specify which columns are to be displayed in the tools list. You achieve this by invoking the header popup menu, accessible with the right mouse click on the list header. Additionally, you can reorder column by dragging them with the mouse.

See also:

Tools
Program settings :: General
Program settings :: Browse mode
Program settings :: View mode
Program settings :: Dialogs
Storing the program settings in a file


Storing the program settings in a file

PhoA program like most Windows applications automatically stores customized settings in the System Registry. These settings cover not only specified in Program settings dialog ones, but also some other interface options such as window sizes, toolbar positions and history lists.

As a bonus you can store settings in a file - it is useful eg when you run the program on another computer and don't want to set up all the parameters again.

PhoA allows storing current program settings as a regular Windows ini file. You perform this by selecting File | Save current settings to file... menu item, or by pressing Shift+Ctrl+S shortcut keys. This invokes standard File Save dialog to enter the name of a file to save settings to. By default the program uses phoa.ini file.

If it is possible to save settings to a file, it is indeed to load them from a file too. You load settings by selecting File | Load settings from file... menu item, or using Shift+Ctrl+O shortcut keys. The dialog that appears you fill the file you have previously saved settings to. By default the phoa.ini file is suggested.

The phoa.ini file have a special meaning: if it is present in the same folder as the program (phoa.exe) itself, it gets loaded when PhoA starts. This default behaviour can be changed in General program settings - the Load settings from phoa.ini if it is present in the program folder, on startup can be turned off which means no phoa.ini autoloading occurs.

NB:
  • It might be already obvious that settings are being loaded in the following order: at first data are loaded from the Registry, and then (if this is enabled) - from phoa.ini. Thus all settings not covered by the file are taken from the Registry.
  • An ini-file stores settings not related to the local machine only. Window sizes, positions, states, toolbar positions and visibility, and also the Tools settings are always being stored locally in the Registry.

See also:

Program settings :: General
Program settings :: Browse mode
Program settings :: View mode
Program settings :: Dialogs
Program settings :: Tools


Picture file operations wizard :: Repair file links options

This wizard page allows specifying parameters for repair picture file links operation.

Not implemented nor documented yet...

See also:

Picture file operations wizard
Browse mode
Working in the browse mode


Picture file operations wizard :: Repair picture file links operation

This operation allows you to repair picture file links broken by some reason by searching the corresponding files in the specified folder.

To perform this operation you need to start the Picture file operations wizard and on the Task selection page select Repair picture file links.

The next pages will be:

  • Picture selection
  • Destination folder selection
  • File links repair options
  • Operation process
  • Operation log

See also:

Picture file operations wizard
Browse mode
Working in the browse mode